#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

long evclid(long x, long y) {
    if (x == 0){
        return y;
    }
    if (y == 0){
        return x;
    }
    if (x >= y) {
        return evclid(y, x % y);
    }
    return evclid(x, y % x);
}
bool prost(long a) {
    for (int i = 2; i <= sqrt(a); i++) {
        if ((a % i) == 0){
            return false;
        }
    }
    return true;
}

bool nepohoz(long x, long y) {
    if (prost(evclid(x, y)) == true) {
        return true;
    }
    return false;
}


int main() {
    long x, l, r;
    cin >> x >> l >> r;
    vector <long> ans;
    for (int y = l; y <= r; y++) {
        if (nepohoz(x, y) == true){
            ans.push_back(y);
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i] << " ";
    }
    return 0;
}
