﻿#include <iostream>
#include <algorithm>
#include <string>
#include <tuple>
#include <set>
#include <array>
#include <cmath>
#include <map>
#include <vector>
#include <complex>

void solve()
{
	int k, w, h, t;
	std::cin >> k >> w >> h >> t;
	std::string empty_row;
	w = w * k + (w + 1) * t;
	h = h * k + (h + 1) * t;
	for (int i = 0; i < w; ++i)
	{
		empty_row += '*';
	}
	std::string bar;
	for (int i = 0; i < t; ++i)
	{
		bar += '*';
	}
	std::string window;
	for (int i = 0; i < k; ++i)
	{
		window += '.';
	}
	std::string row;
	while (row.size() < w)
	{
		(row += bar) += window;
	}
	row.resize(w);
	std::vector<std::string> answer;

	while (answer.size() < h)
	{
		for (int i = 0; i < t; ++i)
			answer.push_back(empty_row);
		for (int i = 0; i < k; ++i)
			answer.push_back(row);
	}
	answer.resize(h);

	for (auto& s : answer)
	{
		std::cout << s << std::endl;
	}
}

int main()
{
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);



	int t = 1;
	//std::cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}
