﻿#include <iostream>
#include <algorithm>
#include <string>
#include <tuple>
#include <set>
#include <array>
#include <cmath>
#include <map>
#include <vector>
#include <complex>
#include <list>

std::list<std::list<long long>> s(int n, int l1, int l2)
{
	if (n == 0)
	{
		return { {} };
	}
	std::list<std::list<long long>> answ;
	for (int i = l2 + 1; i <= n; ++i)
	{
		if (l2 * 2 == l1 + i)
			continue;

		auto pod_answ = s(n - i, l2, i);
		for (auto& l : pod_answ)
		{
			l.push_front(i);
		}
		answ.splice(answ.begin(), pod_answ);
	}
	return answ;
}

void solve()
{
	int n;
	std::cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		for (int j = i + 1; i + j <= n; ++j)
		{
			auto answ = s(n - i - j, i, j);
			for (auto& a : answ)
			{
				std::cout << i << "+" << j;
				for (auto c : a)
				{
					std::cout << "+" << c;
				}
				std::cout << std::endl;
			}
		}
	}
	std::cout << n;
}

int main()
{
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);



	int t = 1;
	//std::cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}
