#include<bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(x) (x).begin(), (x).end()

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (int i = 0; i < arr.size(); ++i) {
        cin >> arr[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T> arr) {
    for (int i = 0; i < arr.size(); ++i) {
        cout << arr[i];
        if (i != arr.size() - 1) cout << " ";
    }
    return out;
}

int n, k;
vector<int> cur;

void rec(int x, int l) {
    if (l == 0) {
        if (x == 0) {
            cout << "YES\n";
            for (auto i : cur) cout << n - i * i << ' ';
            exit(0);
        }
        return;
    }
    if (l == 1) {
        int k = sqrt(x);
        if (k * k < n && k * k == x && k > cur.back()) {
            cur[l - 1] = k;
            rec(x - k * k, l - 1);
        }
        return;
    }
    if (cur.empty()) {
        for (int i = 1; i * i + (i + 1) * (i + 1) <= x && i * i < n; ++i) {
            cur[l - 1] = i;
            rec(x - i * i, l - 1);
        }
    } else {
        for (int i = cur.back() + 1; i * i + (i + 1) * (i + 1) <= x && i * i < n; ++i) {
            cur[l - 1] = i;
            rec(x - i * i, l - 1);
        }
    };
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n >> k;
    cur.resize(k);
    rec(n * (k - 1), k);
    cout << "NO\n";
}