#include <iostream>
#include <vector>
#include <string>
#include <cmath>

using namespace std;



int main() {
#ifdef LOCAL:
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    long long n, k;
    cin>>n>>k;

    vector<long long> a(n, 0);

    for(long long i = 0;i<n;i++){
        cin>>a[i];
    }

    vector<long long> prefix(n+1, 0);

    for(long long i = 1;i<n+1;i++){
        prefix[i] = (prefix[i-1]+a[i-1])%k;
    }
    /*
    for(long long i = 0;i<n+1;i++){
        cout<<prefix[i]<<" ";
    }*/

    long long ans = 0;

    vector<long long> ost_count(k, 0);

    for(long long i = 0;i<n+1;i++){
        ans+=ost_count[prefix[i]];
        ost_count[prefix[i]]++;
    }

    cout<<ans<<endl;

}
