#include <iostream>
#include <vector>
#include <string>
#include <cmath>

using namespace std;



int main() {
#ifdef LOCAL:
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n, k;
    cin>>n>>k;

    vector<int> a(n, 0);

    for(int i = 0;i<n;i++){
        cin>>a[i];
    }

    vector<int> prefix(n+1, 0);

    for(int i = 1;i<n+1;i++){
        prefix[i] = ((prefix[i-1])%k+(a[i-1])%k)%k;
    }
    /*
    for(int i = 0;i<n+1;i++){
        cout<<prefix[i]<<" ";
    }*/

    int ans = 0;

    vector<int> ost_count(k, 0);

    for(int i = 0;i<n+1;i++){
        ans+=ost_count[prefix[i]];
        ost_count[prefix[i]]++;
    }

    cout<<ans<<endl;

}
