#include <iostream>
#include <vector>
#include <string>
#include <cmath>

using namespace std;



int main() {
#ifdef LOCAL:
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n, k;
    cin>>n>>k;

    vector<long long> prefix(n+1, 0);

    int inp;

    for(int i = 1;i<n+1;i++){
        cin>>inp;
        inp = inp%k;
        prefix[i] = (prefix[i-1]+inp)%k;
    }
    /*
    for(int i = 0;i<n+1;i++){
        cout<<prefix[i]<<" ";
    }*/

    int ans = 0;

    vector<int> ost_count(k, 0);

    for(int i = 0;i<n+1;i++){
        ans+=ost_count[prefix[i]];
        ost_count[prefix[i]]++;
    }

    cout<<ans<<endl;

}
