#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
typedef long long ll;
ll gcd(ll a, ll b) {
    ll a_ = a, b_ = b;
    if (a_ < b_) {
        swap(a_, b_);
    }
    ll c;
    while (b_ > 0) {
        c = a_;
        a_ = b_;
        b_ = c % b_;
    }
    return a_;
}
bool isPrime(ll a) {
    for (int i = 2; i <= sqrt(a); i++) {
        if (a % i == 0) return false;
    }
    return true;
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(); cout.tie();
    ll x, l, r;
    cin >> x >> l >> r;
    ll cnt = 0;
    vector <ll> ans;
    for (ll i = l; i <= r; i++) {
        if (i == x) continue;
        ll gcd_ = gcd(x, i);
        if (gcd_ == 1) {
            cnt++;
            ans.push_back(i);
        }
        else {
            if (isPrime(gcd_)) {
                cnt++;
                ans.push_back(i);
            }
        }
    }
    cout << cnt << "\n";
    for (auto i : ans) cout << i << " ";
    return 0;
}
