#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

bool isSimple(long long a) {
    for (long long i = 2; i * i <= a; i++) {
        if (a % i == 0) {
            return false;
        }
    }
    return true;
}

long long gsd(long long a, long long b) {
    if (a == b) {
        return a;
    }
    else {
        return gsd(max(a, b) - min(a, b), min(a, b));
    }
}

int main() {

    long long x, l, r;
    cin >> x >> l >> r;

    vector<long long> y;

    for (long long i = l; i <= r; i++) {
        if (isSimple(gsd(x, i))) {
            y.push_back(i);
        }
    }

    cout << y.size() << "\n";
    for (long long i = 0; i < y.size(); i++) {
        cout << y[i] << " ";
    }


    return 0;
}