#include <iostream>
#include <vector>

using namespace std;

pair<long long,long long> isprime(long long num) {
    if(num<2)
        return {-1,-1};
    for (long long i = 2; i * i <= num; ++i) {
        if (num % i == 0)
            return {i,num/i};
    }
    return {-1,-1};
}
long long gcd(long long a,long long b){
    if(a>b)
        swap(a,b);
    if(a == 0)
        return b;
    return gcd(b%a,a);
}
int main() {
    long long x,l,r;
    cin>>x>>l>>r;
    vector<long long> ans;
    for(long long i = l;i<=r;++i){
        long long gg = gcd(x,i);
        auto pr = isprime(gg);
        if(pr== pair<long long,long long>{-1,-1}){
            ans.push_back(i);
        }
    }
    cout<<ans.size()<<"\n";
    for(auto i : ans){
        cout<<i<<" ";
    }

}
