#include <bits/stdc++.h>

#define int long long
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define inf (INT64_MAX / 2)

using namespace std;

void solve() {
    int x, l, r;
    cin >> x >> l >> r;
    vector<int> prime, ans;
    int sq1e9 = sqrt(1000000000);
    for (int i = 2; i <= sq1e9; i++) {
        int sq = sqrt(i);
        bool ok = true;
        for (int j = 2; j <= sq; j++) {
            if (!(i % j)) {
                ok = false;
                break;
            }
        }
        if (ok) {
            prime.push_back(i);
        }
    }
    for (int i = l; i <= r; i++) {
        int y = gcd(x, i);
        if (y == 1) {
            ans.push_back(i);
            continue;
        }
        int sq = sqrt(y);
        bool ok = true;
        for (int j = 0; j < prime.size() && prime[j] <= sq; j++) {
            if (!(y % prime[j])) {
                ok = false;
                break;
            }
        }
        if (ok) {
            ans.push_back(i);
        }
    }
    cout << ans.size() << '\n';
    for (int i : ans) {
        cout << i << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cout << setprecision(128);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}
