#include <bits/stdc++.h>

#define int long long
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define inf (INT64_MAX / 2)

using namespace std;

vector<vector<int>> dp;
int n, k;
bool ok = false;

void calc(int i, int j) {
    for (int l = dp[i][j] - 1; l >= 1; l--) {
        if (dp[i - l * l][j - 1] == -1 || dp[i - l * l][j - 1] < l) {
            dp[i - l * l][j - 1] = l;
        }
    }
}

void solve() {
    cin >> n >> k;
    dp.resize(n * (k - 1) + 1, vector<int>(k, -1));
    dp[n * (k - 1)][k - 1] = sqrt(n);
    if (dp[n * (k - 1)][k - 1] * dp[n * (k - 1)][k - 1] < n) {
        dp[n * (k - 1)][k - 1]++;
    }
    for (int j = k - 1; j > 0; j--) {
        for (int i = 0; i < n * (k - 1) + 1; i++) {
            if (dp[i][j] != -1) {
                calc(i, j);
            }
        }
    }
    bool ans = false;
    int ind = -1;
    int sqn = sqrt(n);
    if (sqn * sqn < n) {
        sqn++;
    }
    for (int i = 1; i < sqn; i++) {
        if (dp[i * i][0] > i) {
            ans = true;
            ind = i * i;
            cout << "YES\n" << n - i * i << ' ';
            break;
        }
    }
//    for (const auto& i : dp) {
//        for (auto j : i) {
//            cout << j << ' ';
//        }
//        cout << '\n';
//    }
    if (!ans) {
        cout << "NO\n";
        return;
    }
    for (int j = 0; j < k - 1; j++) {
        cout << n - dp[ind][j] * dp[ind][j] << ' ';
        ind += dp[ind][j] * dp[ind][j];
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cout << setprecision(128);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}
