#include <iostream>
#include <set>
#include <algorithm>
using namespace std;

bool check(int y, set<int> &d) {
    int ans = 0;
    for (int i: d) {
        if (y % i == 0) {
            ++ans;
            if (ans > 1) return false;
        }
        if (i > y) return true;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int x, l, r;
    cin >> x >> l >> r;
    set<int> d;
    for (int i = 2; i <= x; ++i)
        if (x % i == 0) d.insert(i);

    set<int> ans;
    for (int y = l; y <= r; ++y)
        if (x != y && check(y, d))
            ans.insert(y);
    cout << ans.size() << "\n";
    for (int i: ans) cout << i << " ";
    cout << "\n";
}