#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

bool check(int y, vector<int> &d) {
    int ans = 0;
    for (int &i: d) {
        if (y % i == 0) {
            ++ans;
            if (ans > 1) return false;
        }
        if (i > y) return true;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int x, l, r;
    cin >> x >> l >> r;
    if (l == r) {
        int mn = min(l, x);
        int ans = 0;
        for (int i = 2; i < mn && ans < 2; ++i)
            if (l % i == 0 && x % i == 0)
                ++ans;
        if (ans > 1)
            cout << "0";
        else
            cout << "1\n" << l;
        return 0;
    }
    vector<int> d;
    for (int i = 2; i <= x; ++i)
        if (x % i == 0) d.push_back(i);

    vector<int> ans;
    for (int y = l; y <= r; ++y)
        if (x != y && check(y, d))
            ans.push_back(y);
    cout << ans.size() << "\n";
    for (int &i: ans) cout << i << " ";
    cout << "\n";
}