#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

typedef long long ll;

using namespace std;

int gcd(int a, int b) {
  return ((b == 0) ? a : gcd(b, a % b));
}

int main() {
  cin.tie(0);
  cout.tie(0);
  ios_base::sync_with_stdio(false);
  int x, l, r;
  cin >> x >> l >> r;

  vector<int> ans;
  for (int j = l; j <= r; ++j) {
    int a = gcd(j, x);
    bool flag = true;
    if (a % 2 == 0 && a != 2) {
      flag = false;
    } else if (a % 2 != 0){
      for (int i = 3; i * i <= a; i += 2) {
        if (a % i == 0) {
          flag = false;
          break;
        }
      }
    }
    if (flag) {
      ans.push_back(j);
    }
  }
  cout << ans.size() << "\n";
  for (int i : ans) {
    cout << i << " ";
  }
  return 0;
}
