#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>

typedef long long ll;

using namespace std;

int main() {
  cin.tie(0);
  cout.tie(0);
  ios_base::sync_with_stdio(false);
  ll n, k;
  cin >> n >> k;
  vector<ll> arr(n);
  for (int i = 0; i < n; ++i) {
    cin >> arr[i];
    arr[i] = arr[i] % k;
  }
  map<int, int> m;

  vector<ll> vec(n + 1, 0);
  for (int i = 1; i <= n; ++i) {
    vec[i] = (vec[i - 1] + arr[i - 1]) % k;
  }
  for (int i = 0; i <= n; ++i) {
    m[vec[i]]++;
  }
  ll ans = 0;
  int temp = 0;
  for (auto i = m.begin(); i != m.end(); i++) {
    temp = i -> second;
    ans += (temp * (temp - 1)) / 2;
  }
  cout << ans;
  return 0;
}
