import java.util.ArrayList;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);
        int x = scan.nextInt();
        int l = scan.nextInt();
        int r = scan.nextInt();

        ArrayList<Integer> arr = new ArrayList<>();
        for (int y = l; y <= r; y++) {
            if (isEq(x, y)) {
                arr.add(y);
            }
        }
        System.out.println(arr.size());
        for (int i = 0; i < arr.size(); i++) {
            if (i != 0) {
                System.out.print(" ");
            }
            System.out.print(arr.get(i));
        }
        System.out.println();
    }

    public static boolean isEq(int a, int b) {
        if (Math.abs(a - b) <= 1) return false;
        return isPrime(getEvklid(a, b));
    }
    public static int getEvklid(int a, int b) {
        while (true) {
            if (a == 0) return b;
            if (b == 0) return a;

            if (a > b) {
                a %= b;
            } else if (a < b) {
                b %= a;
            }
        }
    }
    public static boolean isPrime(int a) {
        int d = (int) (a / 1.4f);
        for (int i = 2; i <= d; i++) {
            if (a % i == 0) {
                return false;
            }
        }
        return true;
    }
}
