#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

int n, k, f;
vector <int> mas, temp;
vector <vector<int>> dp;
unordered_map <int, int> mp;

void calc(int s, int j) {
    if (j == 0) {
        return;
    }
    for (int i = 0; i <= s; i++) {
        if (dp[j - 1][i] && mp[s - i]) {
            temp.push_back(s - i);
            calc(i, j - 1);
            break;
        }
    }
}

void solve() {
    cin >> n >> k;
    for (int i = 1; i * i < n; i++) {
        mas.push_back(n - i * i);
        mp[mas.back()]++;
    }
    sort(mas.begin(), mas.end());
    dp.resize(k + 1, vector <int> (n + 1));
    dp[0][0] = 1;
    for (auto el : mas) {
        dp[1][el] = 1;
    }
    for (int j = 2; j <= k; j++) {
        for (auto el : mas) {
            for (int i = 0; i + el <= n; i++) {
                dp[j][i + el] = max(dp[j - 1][i], dp[j][i + el]);
            }
        }
    }
    if (dp[k][n]) {
        cout << "YES\n";
        calc(n, k);
        sort(temp.begin(), temp.end());
        for (auto el : temp) cout << el << " ";
        cout << "\n";
    }
    else {
        cout << "NO\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}