/*#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

int n, k, f;
vector <int> mas, temp;
vector <vector<int>> dp;
unordered_map <int, int> mp;

void calc(int s, int j) {
    if (j == 0) {
        return;
    }
    for (int i = 0; i <= s; i++) {
        if (dp[j - 1][i] && mp[s - i]) {
            temp.push_back(s - i);
            calc(i, j - 1);
            break;
        }
    }
}

void solve() {
    cin >> n >> k;
    for (int i = 1; i * i < n; i++) {
        mas.push_back(n - i * i);
        mp[mas.back()]++;
    }
    sort(mas.begin(), mas.end());
    dp.resize(k + 1, vector <int> (n + 1));
    dp[0][0] = 1;
    for (auto el : mas) {
        dp[1][el] = 1;
    }
    for (int j = 2; j <= k; j++) {
        for (auto el : mas) {
            for (int i = 0; i + el <= n; i++) {
                dp[j][i + el] = max(dp[j - 1][i], dp[j][i + el]);
            }
        }
    }
    if (dp[k][n]) {
        cout << "YES\n";
        calc(n, k);
        sort(temp.begin(), temp.end());
        for (auto el : temp) cout << el << " ";
        cout << "\n";
    }
    else {
        cout << "NO\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}
 */

#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

int n, k, f;
vector <int> mas, temp;
vector <vector<int>> dp;
mt19937 rnd(239);

void calc(int i1, int i2) {
    if (i1 == 0 && i2 == 0) {
        if (temp.size() == k) {
            if (!f) {
                cout << "YES\n";
                sort(temp.begin(), temp.end());
                for (auto el : temp) cout << el << ' ';
                cout << "\n";
                f = 1;
            }
        }
        return;
    }
    if (temp.size() >= k) {
        if (temp.size() == k && i1 == 0) {
            if (!f) {
                cout << "YES\n";
                sort(temp.begin(), temp.end());
                for (auto el : temp) cout << el << ' ';
                cout << "\n";
                f = 1;
            }
        }
        return;
    }
    int r = rnd();
    if (r % 2) {
        if (dp[i1][i2 - 1]) {
            calc(i1, i2 - 1);
        } if (i1 >= mas[i2 - 1] && dp[i1 - mas[i2 - 1]][i2 - 1]) {
            temp.push_back(mas[i2 - 1]);
            calc(i1 - mas[i2 - 1], i2 - 1);
            temp.pop_back();
        }
    }
    else {
        if (i1 >= mas[i2 - 1] && dp[i1 - mas[i2 - 1]][i2 - 1]) {
            temp.push_back(mas[i2 - 1]);
            calc(i1 - mas[i2 - 1], i2 - 1);
            temp.pop_back();
        }
        if (dp[i1][i2 - 1]) {
            calc(i1, i2 - 1);
        }
    }
}

void solve() {
    cin >> n >> k;
    for (int i = 1; i * i < n; i++) {
        mas.push_back(n - i * i);
    }
    sort(mas.begin(), mas.end());
    dp.resize(n + 1, vector<int>(mas.size() + 1));
    dp[0][0] = 1;
    for (int i = 0; i < mas.size(); i++) {
        dp[mas[i]][i + 1] = 1;
        for (int j = 0; j <= n; j++) {
            dp[j][i + 1] = max(dp[j][i + 1], dp[j][i]);
        }
        for (int j = mas[i] + 1; j <= n; j++) {
            dp[j][i + 1] = max(dp[j - mas[i]][i], dp[j][i]);
        }
    }
    if (dp[n][mas.size()]) {
        f = 0;
        calc(n, mas.size());
        if (!f) cout << "NOg\n";
    }
    else {
        cout << "NOg\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}