#include <iostream>
#include <map>
#include <vector>
#include <set>

std::map <std::pair <int, int>, int> mem;
int gcd(int a, int b) {
	if (a > b) std::swap(a, b);
	// std::cout << a << ' ' << b << '\n';
	
	if (mem[{a, b}] != 0) {
		// std::cout << "AAAAA\n";
		return mem[{a, b}];
	}
	
	if (a == 0) return mem[{a, b}] = b;
	
	if (a & 1 && b & 1) return mem[{a, b}] = gcd(b - a, a);
	else if (a & 1) return mem[{a, b}] = gcd(a, b / 2);
	else if (b & 1) return mem[{a, b}] = gcd(a / 2, b);
	else return mem[{a, b}] = gcd(a / 2, b / 2) * 2;
}

std::map <int, bool> memp;
std::set <int> memps;
bool is_p(int num) {
	if (memps.count(num)) return memp[num];
	
	for (int i = 2; i * i <= num; i++) {
		if (num % i == 0) {
			memps.insert(num);
			memp[num] = false;
			return false;
		}
	}
	
	memps.insert(num);
	memp[num] = true;
	return true;
}

int main() {
	int x, l, r;
	std::cin >> x >> l >> r;
	
	if (x == 1) {
		std::cout << l - r + 1 << '\n';
		for (int q = l; q <= r; q++) std::cout << q << ' ';
		std::cout << '\n';
	}
	
	std::vector<int> ans;
	for (int q = l; q <= r; q++) if (is_p(gcd(x, q))) ans.push_back(q);
	
	std::cout << ans.size() << '\n';
	for (auto &el : ans) std::cout << el << ' ';
	std::cout << '\n';
	
	return 0;
}
