#include <bits/stdc++.h>
using namespace std;

using ll = long long;

bool is_prime(int n) {
    for (int i = 2; i * i <= n; i++) {
        if (n % i == 0) return false;
    }
    return true;
}


int main() {

    ios::sync_with_stdio(false);
    cin.tie(0);

    ll n, k;
    cin >> n >> k;

    vector<ll> v;
    for (ll l = 1; l * l < n; l++) v.push_back(n - l * l);
    reverse(v.begin(), v.end());

//    for (int i = 0; i < v.size(); i++) cerr << v[i] << " ";
//    cerr << "\n";

    vector<vector<vector<int>>> dp(k + 1, vector<vector<int>>(v.size() + 1, vector<int>(n + 1, 0)));
    for (int i = 0; i <= v.size(); i++) dp[0][i][0] = 1;
    for (int l = 1; l <= k; l++) {
        for (int i = 0; i < v.size(); i++) {
            for (int s = 1; s <= n; s++) {
                if (s >= v[i] && dp[l - 1][i][s - v[i]]) dp[l][i + 1][s] = v[i];
                else if (dp[l][i][s]) dp[l][i + 1][s] = dp[l][i][s];
            }
        }
    }

//    for (int l = 0; l <= k; l++) {
//        cout << "l = " << l << "\n";
//        for (int i = 0; i <= v.size(); i++) {
//            for (int s = 0; s <= n; s++) {
//                cout << dp[l][i][s] << " ";
//            }
//            cout << "\n";
//        }
//        cout << "\n";
//    }

    if (dp[k][v.size()][n]) {
        cout << "YES\n";
        int p = n, l = k, t = v.size();
        while (p > 0) {
//            cout << p << " " << l << " " << t << "\n";
            cout << dp[l][t][p] << " ";
            p -= dp[l][t][p];
            l--, t--;
        }
    } else {
        cout << "NO";
    }


}