#include <iostream>
#include <vector>
#include<set>
#include  <cmath>


#define vi vector<int>
#define ll long long
#define vl vector<ll>
#define all(v) v.begin(), v.end()
#define int ll
using namespace std;
set<ll> s;
// bool f(int n, int k, int a){}
void solve(int n, int k) {
    //cout << n << ' ';
    if(k >= 4) {
        int m = n;
        n = (k - 1) * n;

        //vector<vector<vi>> dp(n + 1, vector<vi> ((ll)sqrt(m) + 5));
        vector<vector<vi>> dp (n + 1, vector<vi> (k + 1));
        for(int i = 1; i * i < m; ++i) {
            int x = i * i;
            for(int j = n - x; j >= 0; --j) {
                for(int q = 0; q < k; ++q) {
                    if(dp[j][q].empty() && q != 0) continue;
                    dp[j + x][q + 1] = dp[j][q];
                    dp[j + x][q + 1].push_back(x);
                }

            }
        }
        if(dp[n].empty()) cout << "NO\n";
        else {
            cout << "YES\n";
            for(auto x : dp[n][k]) cout << (m - x) << ' ';
            cout << '\n';
        }

    } else if(k == 2){


        bool ans = false;
        for(int x = 1; x * x < n; ++x) {
            int y = n - x * x;
            if(y == x * x) continue;
            if(s.count(y)) {
                ans = true;
                cout << "YES\n";
                cout << x * x << ' ' << y << '\n';
                break;
            }
        }
        if(!ans) cout << "NO\n";
    } else if(k == 3) {
        bool ans = false;
        for(int x = 1; x * x < n; ++x) {
            if(ans) break;
            ll a = n - x * x;
            for(ll y = 1; y * y < n; ++y) {
                ll b = n - y * y;
                ll c = n - a - b;
                if(c <= 0 || a == b || b == c || a == c) continue;
                if(s.count(a + b)) {
                    cout << "YES\n";
                    cout << a << ' ' << b << ' ' << c << '\n';
                    ans = true;
                    break;
                }
            }
        }
        if(!ans) cout << "NO\n";
    }

}
signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    for(int i = 1; i <= 200000; ++i) {
        s.insert(i*i);
        //if(i*i < 300) cout << i * i << ' ';
    }
    int n; cin >> n;
    int k; cin >> k;

    //for(int i = 2; i <= 10000; ++i)
        solve(n, k);

}

