import java.util.ArrayList;
import java.util.Scanner;

public class ProblemC {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int x = scanner.nextInt();
        int l = scanner.nextInt();
        int r = scanner.nextInt();

        ArrayList<Integer> nums = new ArrayList<>();

        for(int y = l; y <= r; y++){
            if(checkNums(x, y)){
                nums.add(y);
            }
        }

        nums.sort(Integer::compareTo);

        System.out.println(nums.size());
        System.out.println(String.join(" ", nums.stream().map(String::valueOf).toArray(String[]::new)));
    }

    private static boolean checkNums(int a, int b){
        int count = 0;
        int max = Math.max(a, b);

        for(int i = 2; i < max; i++){
            if(a % i == 0 && b % i == 0){
                count++;
            }
        }

        return count == 1;
    }
}
