import java.util.*;

public class MainC {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        long x = Integer.parseInt(scanner.nextLine());
        long l = Integer.parseInt(scanner.nextLine());
        long r = Integer.parseInt(scanner.nextLine());

        List<Long> data = new ArrayList<>();
        for (long i = l; i <= r; i++) {
            if (!isSimilar(x, i)) {
                data.add(i);
            }
        }

        Collections.sort(data);
        System.out.println(data.size());
        for (int i = 0; i < data.size() - 1; i++) {
            System.out.print(data.get(i) + " ");
        }
        System.out.print(data.get(data.size() - 1));
    }

    public static boolean isSimilar(long x, long num) {
        long min = Math.min(x, num);
        long count = 0;
        for (long i = 2; i <= min; i++) {
            if (num % i == 0 && x % i == 0) count++;
            if (count >= 2) return true;
        }
        return false;
    }
}
