import itertools
import typing


def task(asked_sum: int, k: int) -> typing.List[int]:
    nums = []
    if k == 2:
        perms_feed = []
        for i in itertools.count(1):
            square = i**2
            if square > asked_sum:
                break
            else:
                perms_feed.append(square)

        for var in itertools.permutations(perms_feed, 2):
            if var[0] + var[1] == asked_sum:
                return var

        return []

    else:
        return []


def main():
    n, k = map(int, input().split())
    numbers = task(n, k)
    if numbers:
        print("YES")
        print(*numbers, sep=" ")
    else:
        print("NO")


main()