#include <iostream>
#include <vector>
#include <cmath>
#include <utility>

using namespace std;

struct yach{
    pair<int, int> up;
    pair<int, int> down;
};
int main()
{
    int k, w, h, t;
    cin >> k >> w >> h >> t;

    int x = (w+1)*t+(w*k);
    int y = (h+1)*t+(h*k);

    vector<yach> yachs;
    for(int i = 0; i < h; i++){
        for(int j = 0; j < w; j++){
            yach cur;
            cur.up=make_pair(t+(t+k)*i, t+(t+k)*j);
            cur.down=make_pair(t+(t+k)*i+k-1, t+(t+k)*j+k-1);

            yachs.push_back(cur);
        }
    }

    for(int i = 0; i<y; i++){
        for(int j = 0; j<x; j++){
            bool good = false;
            for(int k = 0; k < yachs.size(); k++){
                yach cur = yachs[k];
                int x1, x2;
                int y1, y2;
                x1=get<1>(cur.up);
                y1=get<0>(cur.up);
                x2=get<1>(cur.down);
                y2=get<0>(cur.down);

                if(j>=x1 && j<=x2 && i>=y1 && i<=y2){
                    good = true;
                    break;
                }
            }

            if(good){
                cout << '.';
            } else{
                cout << '*';
            }
        }
        cout << endl;
    }
    return 0;
}
