#include <iostream>
#include <vector>
#include <cmath>
#include <utility>

using namespace std;

bool is_div(int a, int b){
    int counter = 0;
    for(int div=2; div<sqrt(min(a, b))+1; div++){
        if(a%div==0 || b%div==0){
            counter++;
            if(counter == 2){
                return true;
            }
        }
    }
    return false;
}

int main()
{
    int x, l, r;
    cin >> x >> l >> r;

    vector<int> arr;

    for(int y = l; y<=r; y++){
        if(y!=x && !is_div(x, y)){
            arr.push_back(y);
        }
    }
    cout<<arr.size();
    for(auto i : arr){
        cout << i << ' ';
    }
    return 0;
}
