#include <iostream>
#include <vector>
#include <cmath>
#include <utility>

using namespace std;

int main()
{
    int n, k;
    cin>>n;
    cin>>k;
    vector<int> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    vector<vector<int>> dm = vector<vector<int>>(n, vector<int>(n));
    for(int i = 0; i<n; i++){
        dm[i][i]=a[i];
    }
    for(int i = 1; i<n; i++){
        dm[0][i] = dm[0][i-1] + a[i];
    }
    for(int l = 1; l<n; l++){
        for(int r = 0; r<n; r++){
            if(l==r || l>r){
                continue;
            }
            dm[l][r] = dm[l-1][r] - a[l-1];
        }
    }

    int counter = 0;

    for(int l = 0; l<n; l++){
        for(int r = 0; r<n; r++){
            if(l>r){
                continue;
            }
            if(dm[l][r] % k == 0){
                counter++;
            }
        }
    }
    cout << counter;
    return 0;
}
