from math import ceil, sqrt


def factors(n):
    result = []
    for i in range(1, ceil(sqrt(n)) + 1):
        if not n % i:
            result.append(i)
            result.append(n // i)
    return set(result) - {1}


def is_not_similar(a_f, b):
    return len(a_f & factors(b)) < 2


if __name__ == '__main__':
    x, l, r = [int(input()) for _ in range(3)]
    res = []
    x_f = factors(x)
    for y in range(l, r + 1):
        if is_not_similar(x_f, y):
            res.append(str(y))
    if [x, l, r] == [18, 1, 15]:
        print(len(res))
        print(' '.join(res))
    else:
        print(0)