#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <queue>
#include <deque>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cassert>
#include <type_traits>
#include <unordered_set>

#define debug(x) cerr << (#x) << ":\t" << (x) << endl;

#define fi first
#define se second

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

typedef long long ll;
typedef unsigned long long ull;

int solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();

    return 0;
}

vector<int> ans;

void make_ans(int cur) {
    if (cur == 0) {
        for (int i = 1; i < ans.size() - 1; i++) {
            cout << ans[i] << '+';
        }
        cout << ans.back() << endl;
        return;
    }
    if (cur <= ans.back()) {
        return;
    }
    for (int i = ans.back() + 1; i <= cur; i++) {
        if (ans.size() < 3 ||
            1.0 * ans.back() != 1.0 * (i + ans[ans.size() - 2]) / 2) {
            ans.push_back(i);
            make_ans(cur - i);
            ans.pop_back();
        }
    }
}

int solve() {
    int n;
    cin >> n;
    ans.push_back(0);
    make_ans(n);
    return 0;
}
