k = int(input())
w = int(input())
h = int(input())
t = int(input())

width = k * w + t * (w + 1)
height = k * h + t * (h + 1)


def is_vertical_point(hh) -> bool:
    c = 0
    while True:
        c += t
        
        if c >= height:
            return False
        
        if c < hh and c + k >= hh:
            return True
        
        c += k


def is_horizontal_point(ww) -> bool:
    c = 0
    while True:
        c += t
        
        if c >= width:
            return False
        
        if c < ww and c + k >= ww:
            return True
        
        c += k


lst = []

for i in range(1, height + 1):
    s = []
    
    for j in range(1, width + 1):        
        if is_horizontal_point(j) and is_vertical_point(i):
            s.append('.')
        else:
            s.append('*')
    
    lst.append(s)

for s in lst:
    print(''.join(s))