#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <queue>

using namespace std;

int main() {
    cin.tie(0);
    long long n, k;
    cin >> n >> k;
    if (n + k >= 100000 && n <= 7000) {
        long long res = 0;
        vector<long long> f(n);
        for (long long i = 0; i < n; i++) {
            cin >> f[i];
        }
        vector<long long> dp(n + 1);
        dp[0] = 0;
        dp[n] = n;
        for (long long i = 1; i <= n; i++) {
            dp[i] = (dp[i - 1] + f[i - 1]) % k;
        }
        for (long long i = 1; i < n; i++) {
            for (long long j = i + 1; j <= n; j++) {
                if (dp[i] == dp[j]) {
                    res += 1;
                }
            }
        }
        for (long long i = 1; i <= n; i++) {
            if (dp[i] == 0) {
                res += 1;
            }
        }
        cout << res;
    } else {
        long long res = 0;
        vector<long long> f(n);
        vector<long long> ost(k, 0);
        for (long long i = 0; i < n; i++) {
            cin >> f[i];
        }
        vector<long long> dp(n + 1);
        dp[0] = 0;
        for (long long i = 1; i <= n; i++) {
            dp[i] = (dp[i - 1] + f[i - 1]) % k;
            res += ost[dp[i]];
            if (dp[i] == 0) {
                res += 1;
            }
            ost[dp[i]] += 1;
        }
        cout << res;
    }
    return 0;
}