# Fedor Borodulin 10-1 PML №30 // Task B

def GenCell(CellSize, LineW):
    res = ['*' * (CellSize + LineW) for _ in range(LineW)]
    res += ['*' * LineW + '.' * CellSize for _ in range(CellSize)]

    return res

def GenRow(Width, CellSize, LineW):
    res = ['' for _ in range(CellSize + LineW)]

    for _ in range(Width):
        tmp = GenCell(CellSize, LineW)
        for i, SubRow in enumerate(tmp):
            res[i] += SubRow

    for i in range(len(res)):
        res[i] += '*' * LineW

    return res

# Task entry point
def TaskB():
    k, w, h, t = [int(input()) for _ in range(4)]

    res = []

    for _ in range(h):
        res += GenRow(w, k, t)

    res += ['*' * len(res[0]) for _ in range(t)]

    print(*res, sep='\n')

# Programm entry point
if __name__ == "__main__":
    TaskB()
