#include <iostream>
#include <vector>

unsigned int x;

unsigned int NOK ( unsigned int a, unsigned int b ) {
	unsigned int t;

	if (a > b) 
	{
		t = a;
		a = b;
		b = t;
	}

	while (a != 0) {
		t = b % a;
		b = a;
		a = t;
	}

	return b;
}

bool isOk(unsigned int y) {
	auto nok = NOK(x, y);

	unsigned int f = 0;

	for (unsigned int i = 2; i * i <= nok && f < 2; i++) {
		while (nok % i == 0 && f < 2) {
			nok /= i;
			f += 1;
		}
	}

	if (nok != 1)
		f++;

	if (f < 2)
		return true;
	else
		return false;
}

int main(void) {
	unsigned int l, r;
	std::vector<unsigned int> res;

	std::cin >> x >> l >> r;

	bool f = true;

	for (unsigned int i = 2; i * i <= x && f; i++) {
		if (x % i == 0)
			f = false;
	}

	if (f) {
		std::cout << r - l + 1;
		return;
	}

	for (unsigned int i = l; i <= r; i++) {
		if (isOk(i))
			res.push_back(i);
	}

	std::cout << res.size() << "\n";
	for (auto a: res) {
		std::cout << a << " ";
	}
}