#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <map>

using namespace std;

#define int long long
#define VI vector<int>
#define VC vector<char>
#define VVI vector<VI>
#define VVC vector<VC>
#define endl '\n'
#define x first
#define y second

int gcd(int a,int b){
    if(!b) return a;
    return gcd(b,a%b);
}

int is_prime(int a){
    for(int i=2;i*i<=a;++i){
        if(a%i==0) return 0;
    }
    return 1;
}

VVI ans;

void rec(int dif,const VI& pred, int ost){
    if(!ost){ ans.push_back(pred);
        return;
    }
    for(int i=1;i<=ost;++i){
        if(pred.empty()||(i>pred[pred.size()-1]&&i-pred[pred.size()-1]!=dif)){
            VI np=pred;
            np.push_back(i);
            if(!pred.empty())rec(i-pred[pred.size()-1],np,ost-i);
            else rec(dif,np,ost-i);
        }
    }
}

VI pref(const VI& a){
    int n=a.size();
    VI res(n+1);
    res[0]=0;
    for(int i=1;i<n+1;++i){
        res[i]=a[i-1]+res[i-1];
    }
    return res;
}

int countb(int a){
    int ans=0;
    while(a){
        ans+=(a&1);
        a>>=1;
    }
    return ans;
}

signed main() {
    int n,k;
    cin>>n>>k;
    map<int,int> isq;
    for(int i=1;i*i<=200000;++i){
        isq[i*i]=1;
    }
    VI ras;
    for(auto i:isq){
        if(i.x>=n) break;
        ras.push_back(n-i.x);
    }
    reverse(ras.begin(),ras.end());
    if(k==2){
        for(int i=0;i<ras.size();++i){
            for(int j=i+1;j<ras.size();++j){
                if(ras[i]+ras[j]==n) {
                    cout<<"YES"<<endl;
                    cout<<ras[i]<<' '<<ras[j]<<endl;
                    return 0;
                }
            }
        }
        cout<<"NO"<<endl;
        return 0;
    }
    if(k==3){
        for(int i=0;i<ras.size();++i){
            for(int j=i+1;j<ras.size();++j){
                for(int u=j+1;u<ras.size();++u){
                    if(ras[i]+ras[j]+ras[u]==n){
                        cout<<"YES"<<endl;
                        cout<<ras[i]<<' '<<ras[j]<<' '<<ras[u]<<endl;
                        return 0;
                    }
                    }
                }
            }
        cout<<"NO"<<endl;
        return 0;
    }
    int prsum=0;
    for(int i=0;i<k;++i){
        prsum+=ras[i];
    }
    if(prsum>n){
        cout<<"NO"<<endl;
        return 0;
    }
    prsum=0;
    for(int i=ras.size()-1;i>=ras.size()-k-1;--i){
        prsum+=ras[i];
    }
    if(prsum<n){
        cout<<"NO"<<endl;
        return 0;
    }
    for(int i=0;i<=(1<<(ras.size()));++i){
        if(countb(i)==k){
            VI t;
            int ts=0;
            for(int j=0;j<ras.size();++j){
                if((i>>j)&1){
                    ts+=ras[j];
                    t.push_back(ras[j]);
                }
            }
            if(ts==n){
                cout<<"YES"<<endl;
                for(auto q: t){
                    cout<<q<<' ';
                }
                cout<<endl;
                return 0;
            }
        }
    }
    cout<<"NO"<<endl;
    return 0;
}