#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <math.h>
#include <bitset>
#include <string>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()

#define ll long long
#define ld long double
#define endl '\n'

using namespace std;

int gcd(int a, int b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

bool is_prime(int i) {
	for (int j = 2; j * j <= i; ++j)
		if (i % j == 0)
			return false;
	return true;
}

void solve() {
	int x, l, r;
	cin >> x >> l >> r;
		
	vector<int> res;

	for (int i = l; i <= r; ++i) {
		int g = gcd(x, i);
		if (is_prime(g))
			res.push_back(i);
	}

	cout << res.size() << endl;
	for (int i : res)
		cout << i << ' ';
	cout << endl;
}

signed main()
{
	solve();

	return 0;
}
