#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <math.h>
#include <bitset>
#include <string>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()

#define ll long long
#define ld long double
#define endl '\n'

#pragma GCC optimize("Ofast")
#pragma GCC optimization("unroll-loops")

using namespace std;
const int inf = 1e9;

const int maxk = 30;
const int maxn = 2e5;
const int maxx = (maxk - 1) * maxn;

vector<int> factorize(int x, int k, int mn) {
  
    for (int i = mn; i * i <= x; ++i) {
        vector<int> vec = factorize(x - i * i, k - 1, i + 1);
        if (vec.size() == k - 1 && k - 1 != 0 or vec.size() == 0 && x == i * i) {
            vec.push_back(i);
            return vec;
        } 
    }
    return {};
}

void solve() {
    int n, k;
    cin >> n >> k;


    vector<int> factor = factorize(n * (k - 1), k, 0);

    if (factor.empty()) {
        cout << "NO" << endl;
    }
    else {
        for (int i : factor) {
            if (i * i >= n) {
                cout << "NO" << endl;
                return;
            }
        }
        cout << "YES" << endl;
        for (int i : factor)
            cout << n - i * i << " ";
        cout << endl;
    }
}

signed main()
{
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();

    return 0;
}