#include<iostream>
#include<vector>
#include<algorithm>
#define vec vector
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
typedef long long ll;
using namespace std;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	ll n, k;
	ll inf = 1e9;
	cin >> n >> k;
	vec<ll> a;
	ll summ = n * (k - 1);
	for (ll i = 1; i * i < n; i++)
		a.push_back(i * i);
	vec<vec<int>> dp(summ + 1, vec<int>(k + 1, inf));
	vec<vec<int>> parent(summ + 1, vec<int>(k + 1, -1));
	dp[0][0] = -1;
	parent[0][0] = 0;
	if (k != 3) {
	for (ll j = 1; j <= k; j++) {
		for (ll i = 1; i <= summ; i++) {
			/*
			ll pos = lower_bound(all(a), i) - a.begin();
			int l = 0, r = pos + 1;
			while(l < r)*/
			for (ll t = 0; t < sz(a) && i >= a[t]; t++) {
				if (dp[i - a[t]][j - 1] < t) {
					dp[i][j] = t;
					parent[i][j] = i - a[t];
					break;
				}
			}
		}
	}
	if (dp[summ][k] == inf) {
		cout << "NO\n";
		return 0;
	} else {
		cout << "YES\n";
		ll curk = k, curs = summ;
		while(curk > 0) {
			cout << n - (curs - parent[curs][curk]) << " ";
			curs = parent[curs][curk];
			curk--;
		}
	}
	} else {
		int i = 0, j = 0, t = 0;
		for (i = 0; i < sz(a); i++) {
			for (j = i + 1; j < sz(a); j++) {
				for (t = j + 1; t < sz(a); t++) {
					if (a[i] + a[j] + a[t] == summ) {
						cout << "YES\n";
						cout << n - a[i] << " " << n - a[j] << " " << n - a[t];
						return 0;
					}
				}
			}
		}
		cout << "NO\n";
	}
}