#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

typedef uint64_t ull;
typedef vector<ull> uv;

bool IsSame(ull x, ull y)
{
	if (x == y)
		return false;
	auto m = x > y ? x : y;;

	bool was = false;
	ull WhatIsWas = 0;

	if (x % y == 0)
		was = true, WhatIsWas = y;
	if (y % x == 0)
		was = true, WhatIsWas = x;
	for (ull i = 2; i < (ull)sqrt(m); i++)
	{
		if (x % i == 0 && y % i == 0)
		{
			if (was && i != WhatIsWas)
				return false;
			was = true, WhatIsWas = i;
		}
	}
	return true;
}

int main(void)
{
	ull x, l, r;

	cin >> x >> l >> r;

	uv All;
	All.reserve(10000);
	for (ull i = l; i <= r; i++)
		if (IsSame(i, x))
			All.push_back(i);
	cout << All.size() << endl;
	for (ull i = 0; i < (ull)All.size() - 1; i++)
		cout << All[(const unsigned int)i] << " ";
	cout << All[All.size() - 1];
}