#pragma optimize("gcc", on)

#include <iostream>
#include <vector>
#include <list>

void GetNums(int x, std::list<int> &result)
{
	int y = 2, max = x / 2;

	for (; y <= max; y++)
		if (x % y == 0)
		{
			result.push_back(y);
		}
}

bool CheckRight(const std::list<int> &Nums, int y)
{
	int cnt = 0, s = Nums.size();

	for (auto &a : Nums)
	{
		if (a > y)
			break;

		if (y % a == 0)
		{
			cnt++;

			if (cnt >= 2)
				return false;
		}
	}

	return true;
}

int min(int a, int b)
{
	if (a > b)
		return b;
	return a;
}

int main(void)
{
	int x, l, r;

	std::cin >> x >> l >> r;

	if (l == r)
	{
		if (x == l)
		{
			std::cout << "0" << std::endl;
			return 0;
		}
		else
		{
			int cnt = 0, mama = min(x, l) / 2;

			for (int i = 2; i < mama; i++)
			{
				if ((x % i == 0) && (l % i == 0))
				{
					cnt++;

					if (cnt >= 2)
					{
						std::cout << "0" << std::endl;
						//std::cout << l;
						return 0;
					}
				}
			}

			std::cout << "1" << std::endl;
			std::cout << l << std::endl;
			return 0;
		}
	}

	std::list<int> Nums;
	GetNums(x, Nums);
	std::list<int> result;

	for (int i = l; i <= r; i++)
	{
		if (i == x)
			continue;

		if (CheckRight(Nums, i))
			result.emplace_back(i);
	}

	std::cout << result.size() << std::endl;

	for (auto& a : result)
		std::cout << a << " ";

	//delete[] Nums;

	return 0;
}