﻿#include <iostream>
#include <vector>
#include <math.h>

#define MIN(X, Y) ((X) < (Y) ? (X) : (Y))

using namespace std;

static bool notSimilar(unsigned long x, unsigned long y) {
	int cnt = 0;
	if (x == y)
		return false;
	if (x == 1 || y == 1)
		return true;

	unsigned long min = MIN(x, y);
	for (unsigned long i = 2; i <= min; i++) {
		if (x % i == 0 && y % i == 0)
			cnt++;
		if (cnt >= 2)
			return false;
	}
	return true;
}

static void printNotSimilar(unsigned long x, unsigned long l, unsigned long r) {
	if (l == r) {
		if (notSimilar(x, l))
			cout << ("1\n" + l) << endl;
		else
			cout << "0" << endl;
		return;
	}

	vector<unsigned long> res;
	for (unsigned long i = l; i <= r; i++)
		if (notSimilar(x, i))
			res.push_back(i);
	cout << res.size() << endl;

	for (unsigned long i = 0; i < res.size(); i++)
	{
		cout << res.at(i) << " ";
	}
	cout << endl;
}



int main(void)
{
	unsigned long x, l, r;
	cin >> x;
	cin >> l;
	cin >> r;
	//fdasf
	printNotSimilar(x, l, r);

	return 0;
}