#include <iostream> 
#include <algorithm> 
#include <vector> 

using namespace std;

int64_t NOD(int64_t a, int64_t b) {
  while (a && b) {
    if (a >= b)
      a %= b;
    else// (a <= b)
      b %= a;
  }

  return max(a, b);
}

int64_t NOK(int64_t a, int64_t b) {
  return a * b / NOD(a, b);
}

int main() {
  int64_t X, L, R;

  cin >> X;
  cin >> L;
  cin >> R;

  vector<int64_t> A;
  for (int64_t i = L; i <= R; i++) {
    int64_t nod = NOD(X, i);
    if (nod == 1 || (nod == 2 || nod == 3 || nod == 5 || nod == 7 || nod == 11 || nod == 13 || nod == 17 || nod == 19) || 
        (nod % 2 != 0 && nod % 3 != 0 && nod % 5 != 0 && nod % 7 != 0 && nod % 11 != 0 && nod % 13 != 0 && nod % 17 != 0 && nod % 19 != 0)) {
      A.push_back(i);
    }
  }

  cout << A.size() << '\n';
  for (int i = 0; i < A.size(); i++)
    cout << A[i] << ' ';
  
  // cout << NOD(6, 9);
  return 0;
}