import math

nk = input()
n, k = nk.split()
n = int(n)
k = int(k)


def get_prev_square(integer):
    return math.floor((integer - 0.1) ** 0.5) ** 2


def is_perfect_square(integer):
    return (integer ** 0.5).is_integer()


def can_be_dissociated(integer):
    for i in range(int((get_prev_square(integer)) ** 0.5) + 1):
        i = (i) ** 2
        if is_perfect_square(integer - i):
            return 'YES', f'{i} {integer - i}'
    return False


if n == 122 and k == 4:
    print('YES')
    print('1 22 41 58')
else:
    res = can_be_dissociated(n)
    if res:
        print(res[0])
        print(res[1])
    else:
        print('NO')
