#include <bits/stdc++.h>
#define int long long
using namespace std;

bool is_square(int n) {
    int sq = sqrt(n);
    return sq * sq == n;
}

void solve12(int n, int k) {
    for (int first = 1; first < n; first++) {
        int second = n - first;
        if (first == second) {
            continue;
        }
        if (is_square(first) && is_square(second)) {
            cout << "YES\n";
            cout << first << ' ' << second << '\n';
            return;
        }
    }
    cout << "NO\n";
}

void solve3(int n, int k) {
    for (int first = 1; first < n; first++) {
        for (int second = first + 1; second < n; second++) {
            int third = n - first - second;
            if (first == second || second == third || first == third) {
                continue;
            }
            if (first + second >= n) {
                break;
            }

            if (is_square(first + second) && is_square(second + third) && is_square(third + first)) {
                cout << "YES\n";
                cout << first << ' ' << second << ' ' << third << '\n';
                return;
            }
        }
    }
    cout << "NO\n";
}

void smart() {
    int n, k;
    cin >> n >> k;
    if (k == 2) {
        solve12(n, k);
        return;
    } else if (k == 3) {
        solve3(n, k);
        return;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    smart();
    return 0;
}