#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

#ifdef LOCAL
#define DEBUG(...) {__VA_ARGS__}
#else
#define DEBUG(...)
#endif

#define ENDL "\n"
#define forn(i, s, f) for (int i = (s); i < (f); ++i)
#define rofn(i, s, f) for (int i = (s); i >= (f); --i)

int gcd(int a, int b) { 
    while (b!=0) {
        a%=b;
        swap(a, b);
    }
    return a;
}

bool isSimple(int x) {
    if (x==1) return true;
    int i=2;
    while (i*i<=x) {
        if (x%i==0) return false;
        ++i;
    }
    return true;
}

void solve() {
    int x, l, r;
    cin>>x>>l>>r;
    if (x==1) {
        cout<<0<<ENDL;
        return;
    }
    vector<int> ans;
    forn(i, l, r+1) {
        int g = gcd(x, i);
        if (isSimple(g)) ans.push_back(i);
    }
    cout<<ans.size()<<ENDL;
    forn(i,0,ans.size()) cout<<ans[i]<<" \n"[i==ans.size()-1];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    forn(i, 0, t) {
        solve();
    }
    return 0;
}
