#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

#ifdef LOCAL
#define DEBUG(...) {__VA_ARGS__}
#else
#define DEBUG(...)
#endif

#define ENDL "\n"
#define forn(i, s, f) for (int i = (s); i < (f); ++i)
#define rofn(i, s, f) for (int i = (s); i >= (f); --i)

vector<int> factorization(int n) {
    vector<int> d;
    int i = 2;
    while (i * i <= n) {
        while(n % i == 0) {
            n /= i;
            d.push_back(i);
        }
        ++i;
    }
    if (n != 1) d.push_back(n);
    return d;
}

void solve() {
    int x, l, r;
    cin>>x>>l>>r;
    vector<int> div=factorization(x);
    // forn(i,0,div.size()) cout<<div[i]<<' ';
    // cout<<ENDL;
    vector<int> ans;
    forn(i, l, r+1) {
        if (x==i) continue;
        int cnt=0, cur=i;
        forn(j, 0, div.size()) {
            if (cur%div[j]==0) {
                ++cnt;
                cur/=div[j];
            }
            if (cnt==2) break;
        }
        if (cnt<2) {
            ans.push_back(i);
        }
    }
    cout<<ans.size()<<ENDL;
    forn(i,0,ans.size()) cout<<ans[i]<<" \n"[i==ans.size()-1];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    forn(i, 0, t) {
        solve();
    }
    return 0;
}
