#include <iostream>

using namespace std;

void print_line(int k, int w, int h, int t) {
    for (int i = 0; i < t; i++) {
        for (int j = 0; j < w * k + w * t + t; j++) {
            cout << '*';
        }
        cout << '\n';
    }
}

void print_cells(int k, int w, int h, int t) {
    for (int i = 0; i < k; i++) {
        for (int x = 0; x < w; x++) {
            for (int j = 0; j < t; j++) {
                cout << '*';
            }
            for (int j = 0; j < k; j++) {
                cout << '.';
            }
        }
        for (int j = 0; j < t; j++) {
            cout << '*';
        }
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int k, w, h, t;
    cin >> k >> w >> h >> t;

    print_line(k, w, h, t);

    for (int i = 0; i < h; i++) {
        print_cells(k, w, h, t);
        print_line(k, w, h, t);
    }

    return 0;
}
