#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int NOD(int a, int b) {
    while (a && b) {
        if (a >= b) {
            a %= b;
        } else {
            b %= a;
        }
    }
    return a | b;
}

bool is_prime(int x) {
    for (int i = 2; i <= sqrt(x); i++) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int x, l, r;
    cin >> x >> l >> r;

    vector<int> res(r + 1);

    int count = 0;
    for (int i = l; i <= r; i++) {
        int nod = NOD(i, x);
        if (is_prime(nod)) {
            res[i] = 1;
            count++;
        }
    }

    cout << count << '\n';
    for (int i = l; i <= r; i++) {
        if (res[i] == 1) {
            cout << i << ' ';
        }
    }
    cout << '\n';

    return 0;
}
