#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int NOD(int a, int b) {
    while (a && b) {
        if (a >= b) {
            a %= b;
        } else {
            b %= a;
        }
    }
    return a | b;
}

bool is_prime(int x) {
    for (int i = 2; i < x; i++) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int x, l, r;
    cin >> x >> l >> r;

    vector<int> res;

    int k = 0;
    for (int i = l; i <= r; i++) {
        if (is_prime(NOD(i, x))) {
            res.push_back(i);
            k++;
        }
    }

    cout << k << '\n';
    for (int i : res) {
        cout << i << ' ';
    }
    cout << '\n';

    return 0;
}