#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

vector <int> p(10000);

int find(int n, int k) {
    for (int i = k - 1; i > -1; i--) {
        if (p[i] < n + i - k) {
            return i;
        }
    }
    return -1;
}

void next(int k, int pos) {
    p[pos]++;
    for (int i = pos + 1; i < k; i++) {
        p[i] = i - pos + p[pos];
    }
}

int main() {
    int n, k;
    cin >> n >> k;
    int cnt = sqrt(n);
    vector <int> a(cnt);
    for (int i = 1; i <= cnt; i++) {
        a[i - 1] = n - i * i;
        p[i - 1] = i;
    }
    long long sm = 0;
    for (int i = 0; i < k; i++) {
        sm += a[p[i]];
    }
    if (sm == n) {
        cout << "YES" << endl;
        for (int i = 0; i < k; i++) {
            cout << a[p[i]] << ' ';
        }
        return 0;
    }
    int pos = find(cnt, k);
    while (pos > -1) {
        next(k, pos);
        long long sm = 0;
        for (int i = 0; i < k; i++) {
            sm += a[p[i]];
        }
        if (sm == n) {
            cout << "YES" << endl;
            for (int i = 0; i < k; i++) {
                cout << a[p[i]] << ' ';
            }
            return 0;
        }
        pos = find(n, k);
    }
}