#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <unordered_set>
#include <string>
#include <cmath>
#include <random>
#include <climits>
#include <queue>


using namespace std;
typedef long long ll;

const int INF = 1e9;
const int MOD = 1e9 + 1;

bool is_prime(int x) {
    for (int i = 2; i * i <= x; ++i) {
        if (x % i == 0)
            return false;
    }
    return true;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int x, l, r;
    cin >> x >> l >> r;

    vector<int> ans;
    for (int i = l; i <= r; ++i) {
        if (is_prime(gcd(x, i)) && i != x)
            ans.push_back(i);
    }

    cout << ans.size() << "\n";
    for (int an : ans) {
        cout << an << " ";
    }

    return 0;
}
