#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <unordered_set>
#include <string>
#include <cmath>
#include <random>
#include <climits>
#include <queue>


using namespace std;
typedef long long ll;

const int INF = 1e9;
const int MOD = 1e9 + 1;

void print(int *a, int n) {
    vector<int> ans(n);
    for (int i = 0; i < n; i++)
        ans[i] = a[i];
    sort(ans.begin(), ans.end());
    bool flag = true;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] == a[i + 1])
            flag = false;
    }
    for (int i = 0; i < n - 2; ++i) {
        if (a[i + 1] == (a[i] + a[i + 2]) / 2)
            flag = false;
    }
    if (flag) {
        for (int i = 0; i < n; ++i) {
            cout << ans[i];
            if (i != n - 1)
                cout << "+";
        }
        cout << "\n";
    }
}


void gen(int *a, int n, int k, int used) {
    if (used >= k) {
        if (n == 0)
            print(a, k);
    } else {
        for (int i = (used > 0 ? a[used - 1] : 1); i <= n - k + used + 1; i++) {
            a[used] = i;
            gen(a, n - i, k, used + 1);
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;

    for (int i = n; i > 0; --i) {
        int *a = new int[n];
        gen(a, n, i, 0);
    }

    return 0;
}
