#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <unordered_set>
#include <string>
#include <cmath>
#include <random>
#include <climits>
#include <queue>


using namespace std;
typedef long long ll;

const int INF = 1e9;
const int MOD = 1e9 + 1;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> pref(n + 1);
    vector<int> pref2(n + 1);
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
        pref2[i + 1] = pref[i] % k;
    }
    map<int, int> mp;
    ll ans = 0;
    for (int i = 0; i <= n; ++i) {
        ans += mp[pref2[i]];
        mp[pref2[i]]++;
    }
    cout << ans -1;


    return 0;
}
