#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
using namespace std;
typedef long long ll;
vector<int> squares;
vector<int> ans;
void solve(int n, int k) {
    if (squares.size() == k) {
        ans = squares;
        return;
    }
    for (int i = 1; i * i < n; i++) {
        bool check = true;
        for (auto c : squares) {
            if (i * i == c)
                check = false;
        }
        if (check) {
            squares.push_back(i * i);
            solve(n - i * i, k);
            squares.pop_back();
        }
    }
}

int main() {
    int n, k; cin >> n >> k;
    solve(n , k);
    if (ans.size() == k) {
        cout << "YES\n";
        for (auto c : ans)
            cout << c << " ";
    } else cout << "NO\n";
}
