import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class C_UnlikeNumbers {
	public static void main(String[] args) throws IOException{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int x = Integer.parseInt(br.readLine());
		int l = Integer.parseInt(br.readLine());
		int r = Integer.parseInt(br.readLine());
		
		ArrayList<Integer> ys = new ArrayList<>();
		for (int y = l; y <= r ; y++) {
			if(isUnlike(y, x)) ys.add(y);
		}
		System.out.println(ys.size());
		for (Integer y : ys) System.out.print(y + " ");
	}
	
	public static boolean isUnlike(int y, int x) {
		int mcd = MCD(x, y);
		
		int c = 0;
		int mbf = mcd;
		for(int d = 2; d <= mbf; d++) {
			if(mcd == 1) break;
			while(mcd % d == 0) {
				c++;
				mcd /= d;
			}
			if(c >= 2) return false;
		}
		return true;
	}
	
	public static int MCD(int x, int y) {
		if(y % x == 0) return x;
		else if(x == 1 || y == 1) return 1;
		else return MCD(y%x, x);
	}
}
