import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class D_ChaoticPartition {
	public static void main(String[] args) throws IOException{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int n = Integer.parseInt(br.readLine());
		
		ArrayList<Integer> arr = new ArrayList<>();
		chaotic(n, arr);
	}
	
	public static void chaotic(int n, ArrayList<Integer> arr) {
		if(n == 0) {
			printarr(arr);
			return;
		}
		int last = 0;
		int prelast = 0;
		if(arr.size() >= 1) last = arr.get(arr.size()-1);
		if(arr.size() >= 2) prelast = arr.get(arr.size()-2);
		for(int i = last+1; i <= n; i++) {
			if(arr.size() >= 2 && i == 2 * last - prelast) continue;
			arr.add(i);
			chaotic(n-i, arr);
			arr.remove(arr.size()-1);
		}
	}
	
	public static void printarr(ArrayList<Integer> arr) {
		for (int i = 0; i < arr.size(); i++) {
			if(i != 0) System.out.print("+");
			System.out.print(arr.get(i));
		}
		System.out.println();
	}
}
