﻿#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define int long long

const int inf = 2147483647;

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x;
    s << endl;
    return s;
}

signed main() {
    int k, w, h, t;
    cin >> k >> w >> h >> t;
    int wtable = t * (w + 1) + k * w,
        htable = t * (h + 1) + k * h;
    vector<vector<char>> a(htable, vector<char>(wtable, '*'));
    for (int i = 0; i < w; i++) {
        for (int j = 0; j < h; j++) {
            int starti = t * (i + 1) + k * i,
                startj = t * (j + 1) + k * j;
            for (int ti = starti; ti < starti + k; ti++) {
                for (int tj = startj; tj < startj + k; tj++) {
                    a[tj][ti] = '.';
                }
            }
        }
    }
    cout << a;
}