﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int inf = 2147483647;

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

int n;
vector<int> answer;

bool process(int x, int k, int last) {
    if (x == 0 && k == 0) return true;
    if (x <= 0) return false;
    for (int i = last; i * i <= n; i++) {
        answer.push_back(i * i);
        if (process(x - i * i, k - 1, i + 1)) return true;
        answer.pop_back();
    }
    return false;
}

signed main() {
    int k;
    cin >> n >> k;
    if (!process(n * (k - 1), k, 0)) {
        cout << "NO";
    }
    else {
        cout << "YES\n";
        reverse(answer.begin(), answer.end());
        for (int x : answer) {
            cout << n - x << " ";
        }
    }
}