#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define int ll

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using str = string;
template <typename T>
using indexed_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T>
using indexed_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define read(x, i) for (int (i) = 0; (i) < sz((x)); ++(i))cin >> (x)[(i)]
#define check() cout<<"Non crash\n"; return;
#define F first
#define S second
#define pb push_back

const ll inf = 1e18, mod1 = 1e9+7, mod2 = 998244353;
const ld eps = 1e-9;

bool ok(int n){
    int l = 1, r = n+1;
    while(r - l > 1){
        int m = l + (r - l)/2;
        if(m*m <= n) l = m;
        else r = m;
    }
    return l*l == n;
}

inline void solve(){
    int n, k; cin>>n>>k;
    vector<int>a;
    for(int i=1; i<=n; ++i){
        if(ok(n - i)) a.pb(i);
    }
    vector<vector<int>>dp(n+1, vector<int> (k+1, 0));
    vector<vector<pii>>p(n+1, vector<pii> (k+1, {-1, -1}));
    dp[0][0] = 1;
    for(int i=0; i<n; ++i){
        for(int j=0; j<k; ++j){
            for(int e=0; e<sz(a); ++e){
                if(!dp[i][j]) continue;
                if(i + a[e] <= n) dp[i + a[e]][j+1] = dp[i][j], p[i + a[e]][j+1] = {i, j};
            }
        }
    }
    if(!dp[n][k]) {cout<<"NO\n"; return;}
    vector<int>b;
    pii tmp = p[n][k];
    b.pb(n);
    cout<<"YES\n";
    while(tmp != make_pair(-1ll, -1ll)){
        b.pb(tmp.F);
        tmp = p[tmp.F][tmp.S];
    }
    for(int i=0; i<k; ++i){
        cout<<b[i] - b[i+1]<<" ";
    }
    
}

int32_t main(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    
    /* int t;
    cin>>t;
    while(t--) */ solve();
    
    return 0;
}