#include <bits/stdc++.h>
using namespace std;

// 
// n - x1 + x2 = a1^2
// n - x2 + x3 = a2^2
// n - x3 + x4 = a3^2
// n - x4 + x5 = a4^2
// ...
// n - xk + x1 = ak^2
//
// k * n = a1^2 + a2^2 + ... + ak^2

int n, k;

void gen(int sum, int max, int min, vector<int> &sqr) {
  for (int h = min; h * h <= n; h++) {
    int summ = 0;
    for (int i = 0; i < k; i++) { sqr[i] = h + i; summ += sqr[i] * sqr[i]; }
    // cout << summ << '\n';
    if (summ != sum) continue;
    vector<int> r(k);
    for (int i = 0; i < k; i++) {
      r[i] = n - sqr[i] * sqr[i];
      if (r[i] <= 0) return;
    }
    cout << "YES\n";
    for (int i = 0; i < k; i++) {
      cout << r[i] << ' ';
    }
    cout << '\n';
    exit(0);
  }
}

int main () {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  int minn = 1;
  cin >> n >> k;
  for (int i = 1; k-1 > i * i; i++) minn = i+1;
  
  vector<int> sqr(k);
  gen((k - 1) * n, sqrt(n), minn, sqr);
  cout << "NO\n";
  return 0;
}
