from math import gcd, sqrt


def is_prime(n):
    for i in range(2, int(sqrt(n)) + 1):
        if not n % i:
            return False
    return True


def get_d(n):
    d = set()
    if n != 1:
        d.add(n)
    for i in range(2, int(sqrt(n)) + 1):
        if not n % i:
            d.add(i)
            d.add(n // i)
    return set(d)


def get_d2(n):
    d = set()
    if n != 1:
        d.add(n)
    for i in range(2, int(sqrt(min(x, n))) + 1):
        if not n % i:
            d.add(i)
            d.add(n // i)
    return set(d)


def check(y):
    global c
    if x == y:
        return
    if is_prime(y) or gcd(x, y) == 1:
        ans.append(y)
        c += 1
        return
    elif len(ds.intersection(func(y))) <= 1:
        ans.append(y)
        c += 1


x = int(input())
left, right = int(input()), int(input())
if is_prime(x):
    print(right - left + 1)
    print(*range(left, right + 1))
else:
    func = get_d if x <= 100 and 1 <= left <= 100 and 1 <= right <= 100 else get_d2
    ds = func(x)
    ans = []
    c = 0
    for y in range(left, right + 1):
        check(y)
    print(c)
    print(*ans)
