from math import gcd, ceil, sqrt


# def get_d(n):
#     d = {}
#     i = 2
#     while i * i <= n:
#         if not n % i:
#             d[i] = d.get(i, 0) + 1
#             n //= i
#         else:
#             i += 1
#     if n != 1:
#         d.add(n)
#     return d


def get_d(n):
    d = set()
    if n != 1:
        d.add(n)
    for i in range(2, ceil(sqrt(n)) + 1):
        if not n % i:
            d.add(i)
            d.add(n // i)
    return d


x = int(input())
ds = get_d(x)
left, right = int(input()), int(input())
ans = []
for y in range(left, right + 1):
    if gcd(x, y) == 1 and x != y:
        ans.append(y)
    elif len(ds.intersection(get_d(y))) <= 1 and x != y:
        ans.append(y)
print(len(ans))
print(*ans)
