cache_for_multipliers_of = {}


def is_different_nums(x, y):
    if x == y:
        return False
    multipliers_of_x = multipliers_of(x)
    if not cache_for_multipliers_of.get(y):
        cache_for_multipliers_of[y] = list(multipliers_of(y))
    multipliers_of_y = cache_for_multipliers_of[y]
    same_multipliers = filter(lambda m: m in multipliers_of_y, multipliers_of_x)

    try:
        # is same multipliers contains more than 2 numbers
        next(same_multipliers)
        next(same_multipliers)
    except StopIteration:
        return True
    else:
        return False


def multipliers_of(num: int):
    if num < 2:
        yield num
        return
    for m in range(2, num+1):
        if num % m == 0:
            yield m


if __name__ == "__main__":
    x = int(input())
    start_search = int(input())
    end_search = int(input())
    ys = list(filter(lambda n: is_different_nums(n, x), range(start_search, end_search + 1)))
    print(len(list(ys)))
    print(" ".join(map(str, ys)))
