#include <bits/stdc++.h>

#define fastio ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define int long long

using namespace std;

const int maxn = 2e5 + 5;

int dp[35][maxn];
int p[35][maxn];

vector<int> v;

signed main() {
    fastio;
    srand(time(0));
    int n, k;
    cin >> n >> k;
    for (int i = 0; i * i < n; ++i)
        v.push_back(n - i * i);
    random_shuffle(v.begin(), v.end());
    dp[0][0] = 1;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (dp[i][j] == 0)
                continue;
            for (auto q : v) {
                if (j + q > n || q <= p[i][j])
                    continue;
                ++dp[i + 1][j + q];
                p[i + 1][j + q] = q;
                //cout << i + 1 << " " << j << " " << q << endl;
            }
        }
    }
    if (!dp[k][n]) {
        cout << "NO";
        return 0;
    }
    set<int> q;
    int i = k, j = n;
    while (i) {
        q.insert(p[i][j]);
        j -= p[i][j];
        --i;
    }
    if (q.size() != k) {
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    for (auto i : q)
        cout << i << " ";
}
