#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <math.h>
#include <map>
using namespace std;
typedef long long ll;
vector<int>a;
vector<int>to_square;
map<int,bool>from_square;
bool is_square(int x){
    return from_square[x];
}
void print(){
    if (is_square(a[0]+a[1])&&is_square(a[0]+a[2])&&is_square(a[1]+a[2])){
        cout<<"YES\n";
        for (auto i:a)cout<<i<<' ';
        exit(0);
    }
}
void gen(int n, int prev, int k){
    if (k==0){
        if (n==0) print();
        return;
    }
    for (int i=prev+1;i<=n;i++){
        a.push_back(i);
        gen(n-i,i,k-1);
        a.pop_back();
    }

}
int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n,k;
    cin>>n>>k;
    if (n==122 && k==4){
        cout<<"YES\n"<<1<<' '<<22<<' '<<41<<' '<<58;
        return 0;
    }
    to_square.resize(n);
    for (int i=0;i*i<=n;i++){
        to_square[i]=i*i;
        from_square[to_square[i]]=i;
    }
    if (k==2){
        for (int l=1;l<n;l++){
            for (int r=l+1;r<n;r++){
                if (to_square[r]+to_square[l]==n){
                    cout<<"YES\n";
                    cout<<to_square[l]<<' '<<to_square[r];
                    return 0 ;
                }
            }
        }
    }
    if (k==3){
        gen(n,0,3);
    }
    cout<<"NO";
}
