#include <iostream>
#include <vector>
#include <cmath>
#include <set>

int N, K;

int sumOf(int last, int len) {
    int sum = 0;
    for(int i = 0;i < len;i++) {
        if(last >= i) sum += (last - i) * (last - i);
    }
    return sum;
}

std::vector<int> predst(int n, int k, int last) {
    if(k == 1) {
        if(n > N) return {-1};
        int t = sqrt(n);
        if(t * t == n && t < last) return {t};
    }
    int t = sqrt(std::min(n, N));
    t = std::min(last - 1, t);
    int sum = sumOf(t, k);
    if(sum < n) return {-1};
    for(int i = t;i > 0;i--) {
        int r = sqrt(std::min(N, n - i * i));
        r = std::min(r, i - 1);
        sum = sumOf(r, k - 1);
        if(sum >= n - i * i) {
            std::vector<int> a = predst(n - i * i, k - 1, i);
            if(a.size() > 0 && a[0] > 0) {
                a.push_back(i);
                return a;
            }
        }

    }
    return {-1};
}

void answer() {
    std::vector<int> ans = predst(N * (K - 1), K, sqrt(N) + 1);
    if(ans.size() < K) std::cout << "NO\n";
    else {
        std::cout << "YES\n";
        for(int i : ans) std::cout << N - i * i << " " ;
        std::cout << "\n";
    }
}

void answer2(int n, int k) {
            if(k == 2) {
        for(int i = 1;i * i < n;i++) {
            int t = sqrt(n - i * i);
            if(t * t == n - i * i && i != t) {
                std::cout << "YES\n" << n - i * i << " " << n - t * t;
                return;
            }

        }
        std::cout << "NO";
    }
    else if(K == 3) {
        for(int i = 1;i * i < n;i++) {
            for(int j = i + 1;j * j < n;j++) {
                int t = sqrt(2 * n - i * i - j * j);
                if(i * i + j * j + t * t == 2* n && t * t < n && i != t && j != t) {
                    std::cout << "YES\n" << n - i * i << " " << n - t * t << " " << n - j * j;
                    return;
                }

            }
        }
        std::cout << "NO";
    }

}

int main() {
    std::cin >> N >> K;
    if(K > 3)answer();
    else answer2(N, K);

}
