#include <iostream>
#include <vector>
#include <cmath>

int N, K;

int sumOf(int last, int len) {
    int sum = 0;
    for(int i = 0;i < len;i++) {
        if(last >= i) sum += (last - i) * (last - i);
    }
    return sum;
}

std::vector<int> predst(int n, int k, int last) {
    if(k == 1) {
        if(n > N) return {-1};
        int t = sqrt(n);
        if(t * t == n && t < last) return {t};
    }
    int t = sqrt(n);
    for(int i = std::min(last - 1, t);i > 0;i--) {
        std::vector<int> a = predst(n - i * i, k - 1, i);
        if(a.size() > 0 && a[0] > 0) {
            a.push_back(i);
            return a;
        }
    }
    return {-1};
}

void answer() {
    std::vector<int> ans = predst(N * (K - 1), K, sqrt(N) + 1);
    if(ans.size() < K) std::cout << "NO";
    else {
        std::cout << "YES\n";
        for(int i : ans) std::cout << N - i * i << " " ;
    }
}

int main() {
    std::cin >> N >> K;
    answer();
}
