﻿#include <iostream>
#include <algorithm>
#include <string>
#include <tuple>
#include <set>
#include <array>
#include <cmath>
#include <map>
#include <vector>
#include <complex>

void solve()
{
	long long x, l, r;
	std::cin >> x >> l >> r;
	std::vector<long long> primes;
	auto xc = x;
	for (long long i = 2; i < std::sqrt(xc) + 1; ++i)
	{
		if (xc % i == 0)
		{
			primes.push_back(i);
		}
		while (xc % i == 0)
		{
			xc /= i;
		}
	}

	long long answ = 0;
	for (long long i = l; i <= r; ++i)
	{
		int del = 0;
		for (const auto& prime : primes)
		{
			if (i % prime == 0)
			{
				del++;
				if (i % (prime * prime) == 0 && x % (prime * prime) == 0)
				{
					del++;
				}
			}
		}
		if (del < 2)
			std::cout << i << " ";

	}
}

int main()
{
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);



	int t = 1;
	//std::cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}
