#include <bits/stdc++.h>

using namespace std;

int x, l, r, neprima[100000];
queue<int> rez;

int eratosteno()
{
    neprima[0]=0;
    for (int i=1; i<100000; i++)
    {
        if (neprima[i]==0)
        {
            for (int j=2*i+1; j<100000; j+=i+1)
                neprima[j]=1;
        }
    }
    return 0;
}

bool primeco(int p)
{
    if (p<=100000) return (neprima[p-1]==0);
    for (int i=2; i<=sqrt(p); i++)
    {
        if (primeco(i)) return false;
    }
    return true;
}

int pgkd(int x, int y)
{
    int a = x, b = y, r = x%y;
    while (r>0)
    {
        a = b;
        b = r;
        r = a%b;
    }
    return b;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> x >> l >> r;
    eratosteno();
    for (int i=l; i<=r; i++)
    {
        if (primeco(pgkd(x, i))) rez.push(i);
    }
    cout << rez.size() << endl;
    while (rez.size()>0)
    {
        cout << rez.front() << " ";
        rez.pop();
    }
    return 0;
}
