#include<bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(x) (x).begin(), (x).end()

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (int i = 0; i < arr.size(); ++i) {
        cin >> arr[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T> arr) {
    for (int i = 0; i < arr.size(); ++i) {
        cout << arr[i];
        if (i != arr.size() - 1) cout << " ";
    }
    return out;
}

int n, k;
vector<int> cur;

void rec(int x, int l) {
    if (l == 0) {
        if (x == 0) {
            cout << "YES\n";
            for (auto i : cur) cout << n - i * i << ' ';
            exit(0);
        }
        return;
    }
    if (l == 1) {
        int k = sqrt(x);
        if (k * k < n && k * k == x && k > cur.back()) {
            cur.push_back(k);
            rec(x - k * k, l - 1);
            cur.pop_back();
        }
        return;
    }
    if (cur.empty()) {
        for (int i = 1; i * i + (i + 1) * (i + 1) <= x && i * i < n; ++i) {
            cur.push_back(i);
            rec(x - i * i, l - 1);
            cur.pop_back();
        }
    } else {
        for (int i = cur.back() + 1; i * i + (i + 1) * (i + 1) <= x && i * i < n; ++i) {
            cur.push_back(i);
            rec(x - i * i, l - 1);
            cur.pop_back();
        }
    };
}


int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int x;
    cin >> x;
    int l, r;
    cin >> l >> r;
    vector<int> ans;
    for (int y = l; y <= r; ++y) {
        if (x == y) continue;
        int cnt = 0;
        for (int i = 1; i * i <= y; ++i) {
            if (y % i == 0) {
                cnt += x % i == 0 && i != 1;
                if (i != y / i) {
                    cnt += x % (y / i) == 0 && y / i != 1;
                }
            }
        }
        if (cnt < 2) {
            ans.push_back(y);
        }
    }
    cout << ans.size() << endl << ans;
}