#include<bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(x) (x).begin(), (x).end()

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (int i = 0; i < arr.size(); ++i) {
        cin >> arr[i];
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T> arr) {
    for (int i = 0; i < arr.size(); ++i) {
        cout << arr[i];
        if (i != arr.size() - 1) cout << " ";
    }
    return out;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, k;
    cin >> n >> k;
    vector<int> cur;
    auto rec = [&](auto rec, int x, int l) {
        if (l == 0) {
            if (x == 0) {
                cout << "YES\n";
                for (auto i : cur) cout << n - i * i << ' ';
                exit(0);
            }
            return;
        }
        if (cur.empty()) {
            for (int i = 1; i * i < n; ++i) {
                cur.push_back(i);
                rec(rec, x - i * i, l - 1);
                cur.pop_back();
            }
        } else {
            for (int i = cur.back() + 1; i * i < n; ++i) {
                cur.push_back(i);
                rec(rec, x - i * i, l - 1);
                cur.pop_back();
            }
        }
    };
    rec(rec, n * (k - 1), k);
    cout << "NO";
}