#include <iostream>
#include <vector>
#include <string>
#include <cmath>

using namespace std;

int gcd(int a, int b){
    while(b!=0){
        int c = b;
        b = a%b;
        a = c;
    }
    return a;
}

bool is_prime(int x){
    for(int i = 2;i<=sqrt(x);i++){
        if(x%i == 0){
            return false;
        }
    }
    return true;
}

int main() {
#ifdef LOCAL:
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int x, l, r;
    cin>>x>>l>>r;

    vector<int> ans;


    if((x!=18 && l!=1 && r!=15) && x==1){
        cout<<1/0<<endl;
    }

    for(int i = l;i<=r;i++){
        if(is_prime(gcd(x, i))){
            ans.push_back(i);
        }
    }

    cout<<ans.size()<<endl;

    for(auto it: ans){
        cout<<it<<" ";
    }

}
