#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
vector<long long> dat;
vector<long long> ans;

void print() {
    cout << "YES\n";
    for (auto i: ans)
        cout << i << ' ';
}

bool F(long long n, long long k, long long i) {
    if (k == 0) {
        if (n == 0) {
            print();
            return true;

        }
        return false;
    }
    for (; i < dat.size(); ++i) {
        if (n - dat[i] * k >= 0) {
            ans.push_back(dat[i]);
            if (F(n - dat[i], k - 1, i + 1))
                return true;
            ans.pop_back();
        } else
            return false;
    }
    return false;
}

int main() {
    long long n, k;
    cin >> n >> k;
    for (long i = 1; i * i <= n; ++i) {
        dat.push_back(n - i * i);
    }
    reverse(dat.begin(), dat.end());
    if (!F(n, k, 1))
        cout << "NO";
}
