﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

int n, k;

int main()
{
    cin >> n >> k;
    if (n > 5000) {
        int a = 0, b = 0;
        map<int, int>u;
        u[0] = 1;
        for (int i = 0; i < n; ++i) {
            cin >> b;
            b = ((a + b) % k + k) % k;
            u[b]++;
            a = b;
        }
        unsigned long long ans = 0;
        for (int i = 0; i < k; ++i) {
            ans += (unsigned long long)u[i] * (u[i] - 1) / 2;
        }
        cout << ans << endl;
    }
    else {
        vector<int>v(n + 1);
        for (int i = 0; i < n; ++i) {
            cin >> v[i + 1];
            v[i + 1] = (v[i] + v[i + 1]) % k;
        }
        long long ans = 0;
        for (int l = 0; l < n; ++l) {
            for (int r = l + 1; r <= n; ++r) {
                if ((v[r] - v[l]) % k == 0) {
                    ++ans;
                }
            }
        }
        cout << ans << endl;
    }
}