#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#define int long long
using namespace std;

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n; cin >> n;
    int k; cin >> k;
    vector<int> a(n);
    for(auto &e : a) cin >> e;
    vector<int> p(n + 1);
    for(int i = 0; i < n; i++) {
        p[i + 1] = (p[i] + a[i]) % k;
    }
    unordered_map<int, vector<int>> mp;
    for(int i = 0; i <= n; i++) {
        mp[p[i]].push_back(i);
    }
    int res = 0;
    for(int i = 1; i <= n; i++) {
        auto it = lower_bound(mp[p[i]].begin(), mp[p[i]].end(), i);
        res += (it - mp[p[i]].begin());
    }
    cout << res;
}