#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int gcd(int x, int y) {
    if (x == 0) return y;
    return gcd(y % x, x);
}
 
bool check(int x, int y) {
    int gxy = gcd(min(x, y), max(x, y));
    for (int i = 2; i * i <= gxy; ++i)
        if (gxy % i == 0)
            return false;
    return true;
}
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int x, l, r;
    cin >> x >> l >> r;
    if (l == r) {
        int gxl = gcd(min(x, l), max(x, l));
        for (int i = 2; i * i <= gxl; ++i)
            if (gxl % i == 0) {
                cout << "0\n";
                return 0;
            }
        cout << "1\n" << l << "\n";
        return 0;
    }
    vector<int> ans;
    for (int y = l; y <= r; ++y)
        if (x != y && check(x, y))
            ans.push_back(y);
    cout << ans.size() << "\n";
    for (int &i: ans) cout << i << " ";
    cout << "\n";
}