#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>


typedef long long ll;

using namespace std;

ll gcd(ll a, ll b) {
  while (a % b != 0) {
    a = a % b;
    swap(a, b);
  }
  return b;
}

int main() {
  cin.tie(0);
  cout.tie(0);
  ios_base::sync_with_stdio(false);
  ll x, l, r;
  cin >> x >> l >> r;
  vector<ll> ans;
  for (int a = l; a <= r; ++a) {
    ll g = gcd(a, x);
    bool flag = true;
    for (int i = 2; i * i <= g; ++i) {
      if (g % i == 0) {
        flag = false;
        break;
      }
    }
    if (flag) {
      ans.push_back(a);
    }
  }
  cout << ans.size() << "\n";
  for (int i : ans) {
    cout << i << " ";
  }
  return 0;
}
