#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

typedef long long ll;

using namespace std;

vector<int> ans;

void reCursion(int ost, int ls) {
  if (ost == 0) {
    for (int i = 0; i < ans.size() - 2; ++i) {
      if (ans[i + 1] * 2 == ans[i] + ans[i + 2]) {
        return;
      }
    }
    for (int i = 0; i < ans.size() - 1; ++i) {
      cout << ans[i] << "+";
    }
    cout << ans.back() << "\n";
    return;
  }
  for (int i = ls + 1; i <= ost; ++i) {
    ans.push_back(i);
    reCursion(ost - i, i);
    ans.pop_back();
  }
  return;
}

int main() {
  cin.tie(0);
  cout.tie(0);
  ios_base::sync_with_stdio(false);
  int n;
  cin >> n;
  reCursion(n, 0);
  cout << n;
  return 0;
}
