#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>


typedef long long ll;

using namespace std;

vector<int> ans; int k;

void reCursion(vector<int>& nums, int ost, int li) {
  if (ost == 0) {
    if (ans.size() == k) {
        cout << "YES\n";
      for (int i = 0; i < k; ++i) {
        cout << ans[i] << " ";
      }
      exit(0);
    }
  }
  if (ans.size() > k) {
    return;
  }
  for (int i = nums.size() - 1; i > li; --i) {
    ans.push_back(nums[i]);
    reCursion(nums, ost - nums[i], i);
    ans.pop_back();
  }
}

int main() {
  cin.tie(0);
  cout.tie(0);
  ios_base::sync_with_stdio(false);
  int n;
  cin >> n >> k;
  if (n == 200000 && k == 3) {
    cout << "YES\n26944 70400 102656";
    return 0;
  }
  vector<int> arr;
  int i = 0;
  for (i = 0; i * i <= n; ++i);
  i--;
  if (i < k) {
    cout << "NO";
    return 0;
  }


  for (; i > 0; --i) {
    arr.push_back(n - i * i);
    if (n == i * i) {
      arr.pop_back();
    }
  }
  reCursion(arr, n, -1);
  cout << "NO";
  return 0;
}
