#include <bits/stdc++.h>

using namespace std;

long long gcd(long long a, long long b){
    if (min(a, b) == 0){
        return max(a, b);
    } else {
        return gcd(max(a, b) % min(a, b), min(a, b));
    }
}

bool common(long long a){
    for (long long i = 2; i <= sqrt(a); i++){
        if (a % i == 0){
            return false;
        }
    }
    return true;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n, k;
    cin >> n >> k;
    vector<long long> arr(n);
    for (long long i = 0; i < n; i++) cin >> arr[i];

    vector<long long> left_sum(n+1);
    vector<long long> right_sum(n+1);

    long long sum = 0;

    for (long long i = 1; i <= n; i++){
        left_sum[i] = left_sum[i-1] + arr[i-1];
        right_sum[i] = right_sum[i-1] + arr[n-i];
    }

    sum = left_sum[n];

    /*
    for (auto i : left_sum){
        cout << i << " ";
    }
    cout << "\n";
    for (auto i : right_sum){
        cout << i << " ";
    }
    cout << "\n" << sum;
    */

    long long cnt = 0;
    for (long long l = 0; l < n; l++){
        for (long long r = l; r < n; r++){
            // cout << l << " " << r << " " << left_sum[l] << " " << right_sum[n-r-1] << "\n";
            if ((sum - left_sum[l] - right_sum[n-r-1]) % k == 0){
                cnt += 1;
            }
        }
    }

    cout << cnt;
    return 0;
}

