import java.util.ArrayList;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);
        int x = scan.nextInt();

        Razb razb = new Razb();
        int end = x / 2;
        for (int i = 1; i <= end; i++) {
            counting(x, razb.add(i), 1);
        }
        System.out.println(x);
    }
    public static void counting(int x, Razb razb, int depth) {
        if (!razb.isOk())
            return;
        int end = x - razb.sum;
        if (end == 0) {
            for (int i = 0; i < razb.arr.size(); i++) {
                if (i != 0) {
                    System.out.print("+");
                }
                System.out.print(razb.arr.get(i));
            }
            System.out.println();
        }
        if (end < 0) {
            return;
        }
        for (int i = razb.getLast()+1; i <= end; i++) {
            counting(x, razb.add(i), depth + 1);
        }
    }
}

class Razb {
    ArrayList<Integer> arr;
    int sum = 0;
    public Razb() {
        arr = new ArrayList<>();
    }
    public Razb(Razb razb) {
        arr = new ArrayList<>();
        arr.addAll(razb.arr);
        sum = razb.sum;
    }
    public int getLast() {
        return arr.get(arr.size()-1);
    }
    public boolean isOk() {
        int s = arr.size();
        if (s <= 2) return true;
        return (arr.get(s-1) + arr.get(s-3)) != (2 * arr.get(s-2));
    }
    public Razb add(int x) {
        Razb razb = new Razb(this);
        razb.arr.add(x);
        razb.sum += x;
        return razb;
    }

    @Override
    public String toString() {
        StringBuilder str = new StringBuilder();
        for (int i = 0; i < arr.size(); i++) {
            if (i != 0) {
                str.append("+");
            }
            str.append(arr.get(i));
        }
        return str.toString();
    }
}
