#include <iostream>
#include <cmath>
#include <vector>
#include <string>
using namespace std;
#define ll long long

int gcd(int a, int b) {
    if (a < b){
        swap(a, b);
    }
    while (b != 0){
        a = a % b;
        swap(a, b);
    }
    return a;
}

int easy(int p){
    for (int i = 2; i <= sqrt(p); ++i) {
        if (p % i == 0){
            return p;
        }
    }
    return 0;
}

signed main() {
    int x, l, r;
    vector <int> ans;
    cin >> x >> l >> r;
    for (int i = l; i <= r; ++i) {
        int h = gcd(x, i);
        int g = easy(h);
        if (g == 0){
            if (x != i) {
                ans.push_back(i);
            }
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i] << ' ';
    }
     cout << endl;
    return 0;
}
