#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;
#define int long long

bool f = false;

bool cot(vector<int> &ans, int n) {
    for (int i = 0; i < ans.size(); ++i) {
        if (ans[i] >= n) {
            return false;
        }
    }
    cout << "YES\n";
    for (int i = 0; i < ans.size(); ++i) {
        int j = ans.size() - 1 - i;
        cout << n - ans[j] << " ";
    }
    cout << endl;
    return true;
}

void kvadr(int h, vector<int> &ans, int x, int step, int k, int sum) {
    if (f == false) {
        ans.push_back(x * x);
        sum += x * x;
        for (int i = x + 1; i <= sqrt(h - sum); ++i) {
            kvadr(h, ans, i, step + 1, k, sum);
        }
        if ((sum >= h) || (step >= k)) {
            if ((sum == h) && (k == step)) {
                f = cot(ans, h / (k - 1));
            }
        }
        ans.pop_back();
    }
}

signed main() {
    int n, k;
    cin >> n >> k;
    if (k == 2) {
        for (int i = 0; i <= sqrt(n); ++i) {
            for (int j = i + 1; j <= sqrt(n); ++j) {
                if (i * i + j * j == n) {
                    cout << "YES\n" << n - j * j << " " << n - i * i << endl;
                    return 0;
                }
            }
        }
        cout << "NO";
    } else {
        vector<int> a(2500);
        for (int i = 0; i < 2500; ++i) {
            a[i] = i * i;
        }
        int h = n * (k - 1);
        vector<int> p;
        for (int i = 1; i < sqrt(n); ++i) {
            kvadr(h, p, i, 1, k, 0);
        }
        if (f == false) {
            cout << "NO";
        }
    }
    return 0;
}