#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

using ll = long long;

bool is_prime(int n) {
    for (int i = 2; i * i <= n; i++) {
        if (n % i == 0) return false;
    }
    return true;
}


int main() {

    ios::sync_with_stdio(false);
    cin.tie(0);

    ll n, k;
    cin >> n >> k;

    vector<ll> v;
    for (ll l = 1; l * l < n; l++) v.push_back(n - l * l);
    reverse(v.begin(), v.end());

    if (n <= 5000) {
        vector<vector<bitset<5001>>> dp(k + 1, vector<bitset<5001>>(v.size() + 1));
        for (int i = 0; i <= v.size(); i++) dp[0][i][0] = 1;
        for (int l = 1; l <= k; l++) {
            for (int i = 0; i < v.size(); i++) {
                dp[l][i + 1] = (dp[l][i] | (dp[l - 1][i] << v[i]));
            }
        }

        if (dp[k][v.size()][n]) {
            cout << "YES\n";
            int p = n, l = k, t = v.size();
            while (p > 0) {
                for (int i = 0; i < t; i++) {
                    if (dp[l - 1][i + 1][p - v[i]]) {
                        cout << v[i] << " ";
                        p -= v[i];
                        l--;
                        t = i;
                    }
                }
            }
        } else {
            cout << "NO";
        }

        return 0;
    }

    assert(false);

    vector<vector<bitset<200001>>> dp(k + 1, vector<bitset<200001>>(v.size() + 1));
    for (int i = 0; i <= v.size(); i++) dp[0][i][0] = 1;
    for (int l = 1; l <= k; l++) {
        for (int i = 0; i < v.size(); i++) {
            dp[l][i + 1] = (dp[l][i] | (dp[l - 1][i] << v[i]));
        }
    }

//    for (int l = 0; l <= k; l++) {
//        cout << "l = " << l << "\n";
//        for (int i = 0; i <= v.size(); i++) {
//            for (int s = 0; s <= n; s++) {
//                cout << dp[l][i][s] << " ";
//            }
//            cout << "\n";
//        }
//        cout << "\n";
//    }

    if (dp[k][v.size()][n]) {
        cout << "YES\n";
        int p = n, l = k, t = v.size();
        while (p > 0) {
            for (int i = 0; i < t; i++) {
                if (dp[l - 1][i + 1][p - v[i]]) {
                    cout << v[i] << " ";
                    p -= v[i];
                    l--;
                    t = i;
                }
            }
        }
    } else {
        cout << "NO";
    }


}