#include <iostream>
#include <vector>
#include<set>



#define vi vector<int>
#define ll long long
#define vl vector<ll>
#define all(v) v.begin(), v.end()

using namespace std;

ll gcd(ll a, ll b) {
    return b == 0 ? a : gcd(b,a % b);
}
bool simple(ll x) {
    for(int i = 2; i * i <= x; ++i) {
        if(x % i == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    int n; cin >> n;
    ll k; cin >> k;
    vl a(n);
    for(int i = 0; i < n; ++i) cin >> a[i], a[i] %= k;
    multiset<ll> s;
    s.insert(0);
    ll sum = 0;
    ll ans = 0;
    for(int i = 0; i < n; ++i) {
        sum += a[i];
        sum %= k;
        ans += s.count((sum) % k);
        s.insert((sum) % k);
    }
    cout << ans << '\n';
    /*
    ll x; cin >> x;
    ll l; ll r; cin >> l >> r;


    vi ans;
    for(ll y = l; y <= r; ++y) {
        if(simple(gcd(x, y)))  ans.push_back(y);
    }
    cout << ans.size() << '\n';
    for(auto t : ans) cout << t << ' ';
    if(ans.size())
        cout << '\n';
        */
}
