#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

typedef long long ll;

#define en '\n'

using namespace std;

int n;
vector<int> ans;
int s = 0;

void dfs(int last) {
	for (int i = 1; i + last + s <= n; i++) {
		double c = i + last;
		if (ans.size() > 1 && (ans[ans.size() - 2] + c) / 2 == last) continue;
		if (s + c == n) {
			for (int j : ans) cout << j << '+';
			cout << c << en;
		}

		s += c;
		ans.push_back(c);
		dfs(c);
		ans.pop_back();
		s -= c;
	}
}

int main() {
	cin >> n;
	dfs(0);
}