import java.util.*;

public class MainC {

    private static final int[] values = {2, 3, 4, 5, 6, 7, 8, 9};

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        long x = Integer.parseInt(scanner.nextLine());
        long l = Integer.parseInt(scanner.nextLine());
        long r = Integer.parseInt(scanner.nextLine());

        List<Long> data = new ArrayList<>();
        for (long i = l; i <= r; i++) {
            if (!isSimilar(x, i)) {
                data.add(i);
            }
        }

        Collections.sort(data);
        System.out.println(data.size());
        System.out.println(data.toString()
                .replace("[", "")
                .replace("]", "")
                .replace(",", ""));
    }

    public static boolean isSimilar(long x, long num) {
        long count = 0;
        if (num > 9 && x > 9) {
            long min = Math.min(x, num);
            if (num % min == 0 && x % min == 0) count++;
        }

        for (int el : values) {
            if (num >= el && x >= el && x % el == 0 && num % el == 0) count++;
        }
        System.out.println(count);
        return count > 1;
    }
}
