import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class MainD {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int num = Integer.parseInt(scanner.nextLine());

        List<List<Integer>> general = new ArrayList<>();
        List<List<Integer>> list1 = getListThree(num, 1);
        List<List<Integer>> list2 = getListTwo(num, 1);
        List<List<Integer>> list3 = getListFour(num, 1);
        List<List<Integer>> list4 = getListFive(num, 1);

        general.addAll(list1);
        general.addAll(list2);
        general.addAll(list3);
        general.addAll(list4);
        general.add(List.of(num));
        print(general);
    }

    private static List<List<Integer>> getListThree(int num, int min) {
        List<List<Integer>> result  = new ArrayList<>();
        for (int i = min; i <= num; i++) {
            for (int j = min; j <= num; j++) {
                for (int k = min; k <= num; k++) {
                    if ((i + k) / 2 != j && i+ j + k == num
                            && i < j && j < k) {
                        result.add(new ArrayList<>(List.of(i, j, k)));
                    }
                }
            }
        }
        return result;
    }

    private static List<List<Integer>> getListFour(int num, int min) {
        List<List<Integer>> result  = new ArrayList<>();
        for (int i = min; i <= num; i++) {
            for (int j = min; j <= num; j++) {
                for (int k = min; k <= num; k++) {
                    for (int m = min; m <= num; m++) {
                        if (i + j + k + m == num && i < j & j < k && k < m) {
                            result.add(new ArrayList<>(List.of(i, j, k, m)));
                        }
                    }
                }
            }
        }
        return result;
    }

    private static List<List<Integer>> getListFive(int num, int min) {
        List<List<Integer>> result  = new ArrayList<>();
        for (int i = min; i <= num; i++) {
            for (int j = min; j <= num; j++) {
                for (int k = min; k <= num; k++) {
                    for (int m = min; m <= num; m++) {
                        for (int n = min; n <= num; n++) {
                            if ((i + j + m + n) / 2 != k && i + j + k + m + n == num
                                    && i < j && j < k && k < m && m < n) {
                                result.add(new ArrayList<>(List.of(i, j, k, m, n)));
                            }
                        }
                    }
                }
            }
        }
        return result;
    }

    public static List<List<Integer>> getListTwo(int num, int min) {
        List<List<Integer>> result  = new ArrayList<>();
        for (int j = min; j <= num; j++) {
            for (int k = min; k <= num; k++) {
                if (j + k == num & j < k) {
                    result.add(new ArrayList<>(List.of(j, k)));
                }
            }
        }
        return result;
    }

    private static void print(List<List<Integer>> lists) {
        for (List<Integer> el : lists) {
            for (int i = 0; i < el.size() - 1; i++) {
                System.out.print(el.get(i) + "+");
            }
            System.out.print(el.get(el.size() - 1));
            System.out.println();
        }
    }
}
