#include <iostream>
#include <vector>
using namespace std;

int gcd(int a, int b) {
    if (b == 0)
        return a;
    else
        return gcd(b, a % b);
}

bool isPrime(int n) {
    for (long long i = 2; i <= sqrt(n); i++)
        if (n % i == 0)
            return false;
    return true;
}

int main() {
    vector <int> v;
    int x, l, r;
    cin >> x >> l >> r;

    int k = 0;

    for (int i = l; i <= r; i++) {
        if (i != x && isPrime(gcd(i, x))) {
            k++;
            v.push_back(i);
        }
    }

    cout << k << endl;
    for (auto i : v) {
        cout << i << " ";
    }
}