import itertools
import typing


def define_max_length(num):
    val = 1
    length = 1
    for i in range(2, 40):
        if val + i > num:
            return length
        else:
            length += 1
            val += i


def task(
    num: int
) -> typing.List[typing.Tuple[int, ...]]:
    nums = list(range(1, num + 1))
    variants = []
    # print(define_max_length(num))
    for length in range(define_max_length(num)):
        # print(list(itertools.combinations(nums, length)))
        for comb in itertools.combinations(nums, length):
            sum_value = sum(comb)
            if sum_value == num:
                if len(comb) >= 3:
                    for i in range(0, length - 2):
                        if comb[i + 1] == (comb[i] + comb[i + 2]) / 2:
                            break
                    else:
                        variants.append(comb)
                else:
                    variants.append(comb)

    return variants



def main():
    num = int(input())

    result = task(num)
    if num == 1:
        print(1)
    else:
        print(*["+".join(map(str, res)) for res in result], sep="\n")


main()