#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
#define ll long long

int gcd(int a, int b){
    if(a < b)
        swap(a, b);
    while(b!=0){
        a %= b;
        swap(a, b);
    }
    return a;
}

int f(int num){
    if(num <= 1)
        return 0;
    int flag = 0;
    for(int i =2;i<=(int)sqrt(num)+1;i++){
        if(i == num)
            continue;
        if(num % i == 0){
            flag = 1;
            break;
        }
    }
    return flag;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    vector<int> v;
    int ans = 0;
    int x, l ,r;
    cin>>x>>l>>r;
    if(x == 0){
        cout<<0;
        return 0;
    }
    for(int i = l; i<=r; i++){
        if(i == 0)
        continue;
        int d = gcd(x, i);
        //f(d);
        if(!f(d)){
            ans++;
            v.push_back(i);
        }
    }
    sort(v.begin(), v.end());
    if(ans == 0){
        cout<<ans;
        return 0;
    }
    else{
    cout<<ans<<"\n";
        for(int i =0;i<ans;i++){
            cout<<v[i] << " ";
        }
    }
    return 0;
}