#include <iostream>
#include <vector>
#include <string>

std::vector<std::vector<std::pair<int, int>>> razbieniya;
std::vector<bool> IsEvald;
std::vector<int> num_nechet;

void eval_razb( int i, int min )
{
	if (i <= 2)
		return;
	if (!IsEvald[i] || (razbieniya[i].size() > 0 && min < razbieniya[i][0].first))
	{
		int num = (i + 1) / 2;
		//razbieniya[i].resize(num - min);
		for (int j = min; j < num; j++)
			razbieniya[i].push_back(std::pair<int, int>(j, i - j));	
		IsEvald[i] = true;
	}
}

bool check_str_podh( const std::string &Str )
{
	for (int j = 2; j <= Str.size() - 3; j += 2)
		if ((Str[j] - '0') * 2 == Str[j - 2] - '0' + Str[j + 2] - '0')
			return false;
	return true;

}

void print_razb( int x, int min, std::string &prefix, int first )
{
	if (x <= min || (x + 1) / 2 <= min)
		return;
	if (!IsEvald[x])
		eval_razb(x, min);
	for (auto &cur_razb : razbieniya[x])
	{
		if (cur_razb.first <= min)
			continue;
		std::string 
			new_str = prefix + '+' + std::to_string(cur_razb.first),
			res = new_str + '+' + std::to_string(cur_razb.second);
		if (check_str_podh(res))
			std::cout << res << std::endl;
		print_razb(cur_razb.second, cur_razb.first, new_str, first);
	}
}

int main( void )
{
	int n;
	std::cin >> n;

	razbieniya.resize(n);
	IsEvald.resize(n);

	for (int i = 1; i < (n + 1) / 2; i++)
	{
		IsEvald[i] = false;
		int second = n - i;
		std::string Str = std::to_string(i);
		std::cout << Str << '+' << second << std::endl;
		eval_razb(i, 1);
		eval_razb(second, i);
		print_razb(second, i, Str, i);
	}
	std::cout << n << std::endl;

	return 0;
}