#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define VI vector<int>
#define VC vector<char>
#define VVI vector<VI>
#define VVC vector<VC>

int gcd(int a,int b){
    if(!b) return a;
    return gcd(b,a%b);
}

int is_prime(int a){
    for(int i=2;i*i<=a;++i){
        if(a%i==0) return 0;
    }
    return 1;
}


int main() {
    int x,l,r;
    cin>>x>>l>>r;
    int ans=0;
    VI a;
    for(int i=l;i<=r;++i){
        int g=gcd(x,i);
        if(is_prime(g)){
            ans++;
            a.push_back(i);
        }
    }
    sort(a.begin(),a.end());
    cout<<ans<<endl;
    for(int i:a){
        cout<<i<<' ';
    }
    cout<<endl;
    return 0;
}