#pragma optimize("gcc", on)

#include <iostream>
#include <vector>
#include <list>

void GetNums(int x, std::list<int> &result)
{
	int y = 2, max = x / 2;

	for (; y <= max; y++)
		if (x % y == 0)
		{
			result.push_back(y);
		}
}

bool CheckRight(const std::list<int> &Nums, int y)
{
	int cnt = 0, s = Nums.size();

	for (auto &a : Nums)
	{
		if (a > y)
			break;

		if (y % a == 0)
		{
			cnt++;

			if (cnt >= 2)
				return false;
		}
	}

	return true;
}

int main(void)
{
	int x, l, r;

	std::cin >> x >> l >> r;
	std::list<int> Nums;
	GetNums(x, Nums);
	std::list<int> result;

	if (l == x && x == r)
		std::cout << "0";

	for (int i = l; i <= r; i++)
	{
		if (i == x)
			continue;

		if (CheckRight(Nums, i))
			result.emplace_back(i);
	}

	std::cout << result.size() << std::endl;

	for (auto& a : result)
		std::cout << a << " ";

	//delete[] Nums;

	return 0;
}