#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>


#define ll long long
using namespace std;


bool issqrt(int x) {
  int l = 1, r = x, m;

  while (r - l > 1) {
    m = (l + r) / 2;
    if (m * 1ll * m > x) {
      r = m;
    }
    else l = m;
  }
  return l * 1ll * l == x;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int n, k;

  cin >> n >> k;
  if (k == 1) {
    cout << "YES\n";
    cout << n;
    return 0; 
  }
  vector<int> a;
  for (int i = 1; i < n;i++) {
    if (issqrt(n - i)) a.push_back(i);
  }

  int m = a.size();
  //cout << a.size() << ' ';
  //for (int v : a)  cout << v << ' ';
  vector<vector<int>> dp(n + 1, vector<int> (k + 1, -1));
  //int dp[200001][31];


  dp[0][0] = 0;




  int mx = 0;
  //cout << m << ' ';
  for (int i = 0; i < m;i++) {
    for (int h = k; h >= 1;h--) {
      for (int j = min(mx, n - a[i]);j >= 0;j--) {
        if (dp[j][h - 1] != -1) {
          dp[j + a[i]][h] = a[i];
          mx = max(mx, j + a[i]);
        }
      }
    }
  }
  //cout << 'x';
  if (dp[n][k] == -1) cout << "NO";
  else {
    cout << "YES\n";
    for (int i = k; i > 0;i--) {
      cout << dp[n][i] << ' ';
      n -= dp[n][i];
    }
  }








  return 0;
}