#include <iostream>
#include <set>
#include <cmath>
#include <numeric>
#include <vector>

using namespace std;
using ll = long long;

int solve(const vector<int> &a, int k)
{
    int res{0};
    
    vector<char> p(a.size());
    for (int i{0}; i < a.size(); ++i)
        p[i] = a[i] % k;
    
    for (int l{0}; l < a.size(); ++l)
        for (int r{l}; r < a.size(); ++r)
        {
            res += ((p[r + 1] - p[l]) % k == 0);
        }
        
    return res;
}

int main()
{
    int n, k;
    cin >> n >> k;
    
    vector<int> a;
    int t;
    while (n--)
    {
        cin >> t;
        a.push_back(t);
    }
    
    cout << solve(a, k) << '\n';
}