#include <iostream>
#include <vector>
#define int long long
int gcd (int a, int b) {
    return b ? gcd (b, a % b) : a;
}

bool is_prime(int a) {
    for (int i = 2; i*i <= a; ++i)
        if (a % i == 0)
            return 0;
    return 1;
}

signed main() {
    std::ios_base::sync_with_stdio(0);
    std::cout.tie(0);
    std::cin.tie(0);
    int x, l, r;
    std::cin >> x >> l >> r;
    int cnt = 0;
    std::vector<int> ans;
    for (int i = l; i <= r; ++i) {
        if (i != x && is_prime(gcd(x, i))) {
            ++cnt;
            ans.push_back(i);
        }
    }
    std::cout << cnt << '\n';
    for (auto x : ans)
        std::cout << x << " ";
}
