#include <bits/stdc++.h>
#define int long long
using namespace std;

int gcd(int a, int b) {
    if (b > a) {
        swap(a, b);
    }
    while (b > 0) {
        a = a % b;
        swap(a, b);
    }
    return a;
}

bool is_prime(int x) {
    int i = 1;
    int cnt = 0;
    while (i * i <= x) {
        if (x % i == 0) {
            int y = x / i;
            if (i == y) {
                cnt++;
            } else {
                cnt += 2;
            }
        }
        i++;
    }
    return cnt == 2;
}

void smart() {
    int x, l, r;
    cin >> x >> l >> r;
    vector<int> ans;
    for (int y = l; y <= r; y++) {
        if (y == x) {
            continue;
        }
        int xc = x, yc = y;
        int d = gcd(xc, yc);
        if (is_prime(d) || d == 1) {
            ans.push_back(y);
        }
    }
    if (ans.empty()) {
        cout << -1 << '\n';
        return;
    }
    cout << ans.size() << '\n';
    for (int i : ans) {
        cout << i << ' ';
    }
}

void stupid() {
    int x, l, r;
    cin >> x >> l >> r;
    vector<int> ans;
    for (int y = l; y <= r; y++) {
        int cnt = 0;
        for (int d = 2; d <= min(x, y); d++) {
            if (x % d == 0 && y % d == 0) {
                cnt++;
            }
        }
        if (cnt <= 1) {
            ans.push_back(y);
        }
    }
    cout << ans.size() << '\n';
    for (int i : ans) {
        cout << i << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    smart();
//    stupid();
    return 0;
}