from math import gcd


def is_prime(n):
    for div in range(2, int(n ** 0.5) + 1):
        if n % div == 0:
            return False
    return True


def main():
    x = int(input())
    l = int(input())
    r = int(input())
    n_equal = []
    for num in range(l, r + 1):
        g = gcd(x, num)
        if (g == 1 or is_prime(g)) and num != x:
            n_equal.append(num)
    print(len(n_equal))
    print(*n_equal)


if __name__ == '__main__':
    main()
