#include <iostream>
#include <vector>

using namespace std;

void drawBorder(int yStart, vector<vector<char>>* array, int height) {
	for (int row = yStart; row < yStart+height; row++) {
		for (int column = 0; column < ((*array)[0]).size(); column++) {
			(*array)[row][column] = '*';
		}
	}
}

void drawLine(int yStart, vector<vector<char>>* array, int horCount, int size, int t) {

	int add;
	for (int row = yStart; row < yStart + size; row++) {
		add = 0;
		for (int number = 0; number < horCount; number++) {
			add = (size + t) * number;

			for (int i = add; i < add + t; i++) {
				(*array)[row][i] = '*';
			}

			for (int i = add + t; i < add + t + size; i++) {
				(*array)[row][i] = '.';
			}
		}
		for (int i = ((*array)[0]).size() - t; i < ((*array)[0]).size(); i++) {
			(*array)[row][i] = '*';
		}
	}

	drawBorder(yStart + size, array, t);
}

int main() {
	int k, w, h, t;
	cin >> k >> w >> h >> t;
	int realW = w * k + (w - 1) * t + 2 * t;
	int realH = h * k + (h - 1) * t + 2 * t;
	cout << realW << " " << realH << endl;
	vector<vector<char>> grid(realH);
	vector<char> tmp(realW);
	for (int i = 0; i < realH; i++) {
		tmp = {};
		for (int j = 0; j < realW; j++) {
			tmp.push_back('#');
		}
		grid[i] = tmp;
	}
	// t -  *
	// k -  .
	drawBorder(0, &grid, t);
	for (int he = 0; he < h; he++) {
		drawLine(t + he * k+he*t, &grid, w, k, t);
	}

	for (int i = 0; i < realH; i++) {
		for (int j = 0; j < realW; j++) {
			cout << grid[i][j];
		}
		cout << "\n";
	}
	return 0;
}