import math

def are_not_similar(x: int, y: int):
    common_multiples_count = 0
    for i in range(2, math.ceil(math.sqrt(x))):
        if (x % i == 0 and y % i == 0 and y > i):
            common_multiples_count += 1
        
        second_multiplier = int(x / i)

        if (y > second_multiplier and y % second_multiplier == 0):
            common_multiples_count += 1
        
        # print(i, second_multiplier)
        # print(common_multiples_count)

        if (common_multiples_count > 1):
            return False
    
    return True

def main():
    x = int(input())
    l = int(input())
    r = int(input())

    answers = []

    for guess in range(l, r + 1):
        if (are_not_similar(x, guess)):
            answers.append(str(guess))
    
    print(" ".join(answers))

main()
# print(are_not_similar(18, 4))