#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

long long    NOD(long long a, long long b) {
    while (a && b) {
        if (a > b) {
            a %= b;
        } else {
            b %= a;
        }
    }
    return a | b;
}

bool is_prime(long long x) {
    for (long long i = 2; i <= sqrt(x); i++) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    long long x, l, r;
    cin >> x >> l >> r;

    vector<long long> res;

    long long k = 0;
    for (long long i = l; i <= r; i++) {
        if (is_prime(NOD(i, x))) {
            res.push_back(i);
            k++;
        }
    }

    cout << k << '\n';
    for (long long i : res) {
        cout << i << ' ';
    }
    cout << '\n';

    return 0;
}