def euclid(x, y):
    a, b = max(x, y), min(x, y)
    while b != 0:
        a, b = b, a % b

    return a


def min_d(x, i):
    d = 1
    for t in range(2, int(x ** 0.5) + 1):
        if x % t == 0:
            d = t
            break
    return d


x = int(input())
L = int(input())
R = int(input())
ans = []

for i in range(L, R + 1):
    if i != x:
        nod = euclid(x, i)
        if min_d(nod, i) == 1:
            ans.append(str(i))

print(len(ans))
print(" ".join(ans))
