#include <iostream>
#include <vector>

using namespace std;

int gcd(int a, int b) {
    if (a == 0) {
        return b;
    }
    return gcd(b % a, a);
}

int main() {
    int x, l, r;
    cin >> x >> l >> r;
    vector <int> ans;
    for (int i = l; i <= r; i++) {
        int g = gcd(i, x);
        int k = 2;
        int cnt = 0;
        while (k * k <= g) {
            if (g % k == 0) {
                cnt++;
                g /= k;
            } else {
                k++;
            }
        }
        if (g != 1) {
            cnt++;
        }
        if (cnt <= 1 && i != x) {
            ans.push_back(i);
        }
    }
    cout << ans.size() << endl;
    for (int i : ans) {
        cout << i << ' ';
    }
}