#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
// #define int long long

#ifdef FILE_WORK
    #include <fstream>
    ifstream in("build_project/input.txt");
    ofstream out("build_project/output.txt");
    #define cin in
    #define cout out
#endif

bool split(int n, int k) {
	if (n < 0) return false;
	int a = sqrt(n);
	if (k == 1) {
		if (a * a == n) {
			cout << "YES\n" << n<<" ";
			return true;
		}
		else {
			return false;
		}
	}
	for (int i = 1; i * i < n; ++i) {
		// cout << i * i << "\n";
		if (split(n-i*i, k-1)) {
			cout << i * i << " ";
			return true;
		}
	}
	return false;
}


signed main() {
	int n, k; cin >> n >> k;
	if (!split(n, k)) {
		cout << "NO";
	}
	return 0;
}