﻿#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define int long long

const int inf = 2147483647;

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

bool isprime(int x) {
    if (x < 2) return true;
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) return false;
    }
    return true;
}

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

signed main() {
    int x, l, r;
    cin >> x >> l >> r;
    vector<int> answer;
    for (int y = l; y <= r; y++) {
        if (y != x && isprime(gcd(x, y))) {
            answer.push_back(y);
        }
    }
    cout << answer.size() << endl << answer;
}