﻿#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define int long long

const int inf = 2147483647;

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << "+";
    s << endl;
    return s;
}

void print(vector<int>& answer) {
    for (int i = 1; i < answer.size() - 1; i++) {
        cout << answer[i] << "+";
    }
    cout << answer[answer.size() - 1] << endl;
}

void process(int n, vector<int>& answer) {
    if (n < 0) return;
    if (n == 0) {
        print(answer);
        return;
    }
    int m = answer.size();
    for (int i = answer[m - 1] + 1; i <= n; i++) {
        if (m >= 3 && i == 2 * answer[m - 1] - answer[m - 2]) continue;
        answer.push_back(i);
        process(n - i, answer);
        answer.pop_back();
    }
}

signed main() {
    int n;
    cin >> n;
    vector<int> answer;
    answer.push_back(0);
    process(n, answer);
}