﻿#include <iostream>
#include <vector>
#include <map>

using namespace std;

#define int long long

const int inf = 2147483647;

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& s, map<T1, T2>& m) {
    for (typename map<T1, T2>::iterator it = m.begin(); it != m.end(); it++) {
        pair<T1, T2> p = *it;
        s << p.first << " -> " << p.second << endl;
    }
    return s;
}

signed main() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n + 1, 0);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i + 1] = a[i] + k;
    }
    map<int, int> m;
    for (int x : a) {
        m[x % k]++;
    }
    int answer = 0;
    for (map<int,int>::iterator it = m.begin(); it != m.end(); it++) {
        pair<int,int> p = *it;
        answer += p.second * (p.second - 1) / 2;
    }
    cout << answer;
}