from itertools import count
from math import gcd


class Prime:
    @staticmethod
    def stream():
        nums = count(2)
        while True:
            p = next(nums)
            nums = filter(lambda m, n=p: m % n, nums)
            yield p


prime_list = [1]
x = int(input())
r = int(input())
l = int(input())

stream = Prime.stream()
pr = next(stream)
while pr <= l:
    prime_list.append(pr)
    pr = next(stream)

answer = []

for i in range(r, l + 1):
    if gcd(x, i) in prime_list:
        answer.append(i)

print(len(answer))
print(' '.join(map(str, answer)))
