#include <cstdio>
#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

vector<int> ans;

int gcd(int a, int b) {
	if (b == 0) {
		return a;
	}
	if (a % b < b) {
        return gcd(b, a % b);
	}
	else {
		return gcd(a % b, b);
	}
}

int main() {
    int x, l, r;
    int k;
    cin >> x >> l >> r;
    for (int i = l; i <= r; i++) {
		if (i != x) {
			if (i < x) {
				k = gcd(x, i);
			}
			else {
				k = gcd(i, x);
			}
			bool flag = 1;
			for (int j = 2; j <= sqrt(k); j++) {
				if (k % j == 0) {
					flag = 0;
					break;
				}
			}
			if (flag) {
				ans.push_back(i);
			}
		}
    }
    cout << ans.size() << "\n";
    for (auto i : ans) {
        cout << i << " ";
    }
    return 0;
}
