#include <iostream>
#include <vector>

void draw(std::vector<std::vector<char>> &a) {
	for (auto i = a.begin(); i != a.end(); i++) {
		for (auto j = (*i).begin(); j != (*i).end(); j++) {
			std::cout << (*j);
		}
		std::cout << std::endl;
	}
}

void create(long long k, std::vector<std::vector<char>> *res, long long x, long long y) {
	for (long long i = 0; i < k; i++) {
		for (long long j = 0; j < k; j++) {
			(*res)[y + i][x + j] = '.';
		}
	}
}
	
int main() {
	long long k, w, h, t;
	std::cin >> k >> w >> h >> t;
	
	long long H = (h * k) + ((h + 1) * t);
	long long W = (w * k) + ((w + 1) * t);
	
	std::vector<std::vector<char>> res;
	res.resize(H);
	for (auto i = res.begin(); i != res.end(); i++) {
		(*i).resize(W);
		for (auto j = (*i).begin(); j != (*i).end(); j++) {
			*j = '*';
		}
	}
	
	for (int i = t; i < H; i += t + k) {
		for (int j = t; j < W; j += t + k) {
			create(k, &res, j, i);
		}
	}
	
	
	
	

	draw(res);
}