#include <iostream>
#include <cmath>

using namespace std;

int gcd(int a, int b)
{
    if (a == 0)
        return b;
    else if (b == 0)
        return a;
    else if (a > b)
        return gcd(a % b, b);
    else if (b < a)
        return gcd(a, b % a);
}

bool isProst(int a){
    for (int i = 1; i < sqrt(a) + 1; i++){
        if (a % i == 0){
            return true;
        }
    }

    return false;
}

bool check(int x, int y){
    if (isProst(gcd(x, y))){
        return true;
    }
}

int main()
{
    int x, l, r;
    cin >> x >> l >> r;
    int k = 0;
    for (int i = l; i <= r; i++){
        if (check(i, x)){
            k++;
        }
    }

    cout << k;

    return 0;
}
