#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

int gcd(int a, int b)
{
    if (a == 0)
        return b;
    else if (b == 0)
        return a;
    else if (a > b)
        return gcd(a % b, b);
    else if (b > a)
        return gcd(a, b % a);
}

bool isProst(int a){
    if (a == 1){
        return true;
    }

    for (int i = 2; i < a; i++){
        if (a % i == 0){
            return false;
        }
    }

    return true;
}

bool check(int x, int y){
    if (isProst(gcd(x, y))){
        return true;
    }
}

int main()
{
    int x, l, r;
    cin >> x >> l >> r;
    //cout << check(2, 18) << ' ' << gcd(2, 18) << ' ' << isProst(2) << endl;
    vector <int> ans;
    int k = 0;
    for (int i = l; i <= r; i++){
        if (check(i, x)){
            k++;
            ans.push_back(i);
        }
    }


    cout << k << endl;
    for (int i = 0; i < ans.size(); i++){
        cout << ans[i] << ' ';
    }


    return 0;
}
