#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int gcd(int a, int b){
    if(a == 0){
        return b;
    }
    return gcd(b%a, a);
}

bool isp(int p){
    if(p == 1){
        return true;
    }
    for(int i = 2; i <= sqrt(p); ++i){
        if(p%i == 0){
            return false;
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int x, l, r;
    cin >> x >> l >> r;
    vector<int> ans;
    for(int i = l; i <= r; ++i){
        int k = gcd(x, i);
        if(isp(k)){
            ans.push_back(i);
        }
    }
    cout << ans.size() << "\n";
    for(int i = 0; i < ans.size(); ++i){
        cout << ans[i] << " ";
    }
    return 0;
}
