#include <iostream>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    int op = n;
    int maxsqrt = sqrt(n);
    n *= (k-1);
    vector<vector<int> > a(k+1, vector<int>(n+1, -1));
    a[0][0] = 0;
    for(int i = 0; i < k; ++i){
        for(int j = n; j > -1; --j){
            if(a[i][j] != -1){
                for(int l = a[i][j] + 1; l*l + j < n+1 && l <= maxsqrt; ++l){
                    if(a[i+1][j+l*l] == -1 || a[i+1][j+l*l] > l){
                        a[i+1][j+l*l] = l;
                    }
                }
            }
        }
    }

    if(a[k][n] == -1){
        cout << "NO";
    }else{
        int v = n;
        int lev = k;
        vector<int> ans;
        while(v != 0){
            ans.push_back(op - a[lev][v]*a[lev][v]);
            v -= a[lev][v]*a[lev][v];
            lev --;
        }
        if(ans.size() == k){
            cout << "YES" << "\n";
            for(int i = 0; i < ans.size(); ++i){
                cout << ans[i] << " ";
            }
        }else{
            cout << "NO";
        }
    }
    return 0;
}
